unit CheckPrevious;

interface

Uses
  Windows, SysUtils, Classes, MP3SE_Types;

function RestoreIfRunning(const AppHandle: THandle; MaxInstances: integer = 1): Boolean;

implementation

var
  MappingHandle: THandle;
  InstanceInfo: PInstanceInfo;
  MappingName : string;
  RemoveMe : boolean = True;

function RestoreIfRunning(const AppHandle: THandle; MaxInstances: integer = 1): Boolean;
var
  lastError: Cardinal;
  i: Integer;
begin
    Result := False;
    MappingName := MP3SE_MAPNAME;
    MappingHandle := CreateFileMapping($FFFFFFFF,
                                     nil,
                                     PAGE_READWRITE,
                                     0,
                                     SizeOf(TInstanceInfo),
                                     PChar(MappingName));
    lastError := GetLastError;
    if MappingHandle = 0
        then RaiseLastOSError
    else begin
        if lastError <> ERROR_ALREADY_EXISTS then begin
            InstanceInfo := MapViewOfFile(MappingHandle,
                                    FILE_MAP_ALL_ACCESS,
                                    0,
                                    0,
                                    SizeOf(TInstanceInfo));
            InstanceInfo^.PreviousHandle := AppHandle;
            InstanceInfo^.RunCounter := 1;
            InstanceInfo^.FileListReady := True;
            InstanceInfo^.FileListEmpty := True;
            Result := False;
        end
        // already runing
        else begin
            MappingHandle := OpenFileMapping(FILE_MAP_ALL_ACCESS, False, PChar(MappingName));
            if MappingHandle <> 0 then begin
                InstanceInfo := MapViewOfFile(MappingHandle,
                                      FILE_MAP_ALL_ACCESS,
                                      0,
                                      0,
                                      SizeOf(TInstanceInfo));
                Result := True;
                if InstanceInfo^.RunCounter >= MaxInstances then begin
                    RemoveMe := False;
                    if IsIconic(InstanceInfo^.PreviousHandle)
                        then ShowWindow(InstanceInfo^.PreviousHandle, SW_RESTORE);
                    SetForegroundWindow(InstanceInfo^.PreviousHandle);
                    //* store file list
                    if ParamCount > 0 then begin
                        while NOT InstanceInfo^.FileListEmpty
                            do Sleep(250);
                        if InstanceInfo^.FileList[0] = '' then begin
                            InstanceInfo^.FileListEmpty := False;
                            for i := 1 to ParamCount do begin
                                if FileExists(ParamStr(i))
                                    then InstanceInfo^.FileList[i-1] := ParamStr(i);
                            end;
                        end;
                    end;
                    //*
                end else begin
                    InstanceInfo^.PreviousHandle := AppHandle;
                    InstanceInfo^.RunCounter := 1 + InstanceInfo^.RunCounter;
                end;
            end;
        end;
    end;
end;

initialization

finalization
  // remove one instance
    if RemoveMe then begin
        MappingHandle := OpenFileMapping(FILE_MAP_ALL_ACCESS, False, PChar(MP3SE_MAPNAME));
        if MappingHandle <> 0 then begin
            InstanceInfo := MapViewOfFile(MappingHandle,
                                  FILE_MAP_ALL_ACCESS,
                                  0,
                                  0,
                                  SizeOf(TInstanceInfo));
            InstanceInfo^.RunCounter := -1 + InstanceInfo^.RunCounter;
        end else RaiseLastOSError;
    end;
    if InstanceInfo <> nil
        then UnmapViewOfFile(InstanceInfo);
    if MappingHandle <> 0
        then CloseHandle(MappingHandle);
end.
