library MetaData;

 { MetaData.Dll (C) 2004 Copyright Philip Hadar }

uses
 ShareMem, SysUtils, Windows, Dialogs;

 {$R *.RES}

 Const
 IID_IWMMetadataEditor: TGUID = '{96406bd9-2b2b-11d3-b36b-00c04f6108ff}';
 IID_IWMHeaderInfo    : TGUID = '{96406bda-2b2b-11d3-b36b-00c04f6108ff}';
 IID_IWMHeaderInfo3   : TGUID = '{15CC68E3-27CC-4ecd-B222-3F5D02D80BD5}';
 IID_IWMHeaderInfo2   : TGUID = '{15cf9781-454e-482e-b393-85fae487a810}';

 LibName = 'WMVCORE.DLL';

 Type
 TTagsData = Packed Record
 Encoder, Version, Genre, Author, Title, Album,
 Composer, Url, Track, Year, CopyRight: String[255];
 Comments, Lyrics: WideString;
 Duration, BitRate, FileSize: LongInt;
 VBR: Boolean;
 End;
 PTagsData = ^TTagsData;

 Type

 WMT_CODEC_INFO_TYPE = LongWord;

 WMT_ATTR_DATATYPE =
 ( WMT_TYPE_DWORD,
   WMT_TYPE_STRING,
   WMT_TYPE_BINARY,
   WMT_TYPE_BOOL,
   WMT_TYPE_QWORD,
   WMT_TYPE_WORD,
   WMT_TYPE_GUID );

 TWMTAttrDataType = WMT_ATTR_DATATYPE;

 Type
 IWMMetadataEditor = interface(IUnknown)
 ['{96406BD9-2B2B-11d3-B36B-00C04F6108FF}']
   Function Open(pwszFilename: PWideChar): HRESULT; stdcall;
   Function Close: HRESULT; stdcall;
   Function Flush: HRESULT; stdcall;
 end;

 Type
 IWMHeaderInfo = interface(IUnknown)
 ['{96406BDA-2B2B-11d3-B36B-00C04F6108FF}']
   Function GetAttributeCount(wStreamNum: Word; out pcAttributes: Word): HRESULT; stdcall;
   Function GetAttributeByIndex(wIndex: Word; var pwStreamNum: Word;
    pwszName: PWideChar; var pcchNameLen: Word;
     out pType: TWMTAttrDataType;pValue: PBYTE;
     var pcbLength: Word): HRESULT; stdcall;
   Function GetAttributeByName(var pwStreamNum: Word; pszName: PWideChar;
     out pType: TWMTAttrDataType;pValue: PBYTE;
     var pcbLength: Word): HRESULT; stdcall;
   Function SetAttribute(wStreamNum: Word; pszName: PWideChar;
     Type_: TWMTAttrDataType; {in} pValue: PBYTE;
     cbLength: Word): HRESULT; stdcall;
   Function GetMarkerCount(out pcMarkers: Word): HRESULT; stdcall;
   Function GetMarker(wIndex: Word;pwszMarkerName: PWideChar;
     var pcchMarkerNameLen: Word; out pcnsMarkerTime: Int64): HRESULT; stdcall;
   Function AddMarker(pwszMarkerName: PWideChar; cnsMarkerTime: Int64): HRESULT; stdcall;
   Function RemoveMarker(wIndex: Word): HRESULT; stdcall;
   Function GetScriptCount(out pcScripts: Word): HRESULT; stdcall;
   Function GetScript(wIndex: Word;pwszType: PWideChar;
     var pcchTypeLen: Word;pwszCommand: PWideChar;
     var pcchCommandLen: Word; out pcnsScriptTime: Int64): HRESULT; stdcall;
   Function AddScript(pwszType, pwszCommand: PWideChar;
     cnsScriptTime: Int64): HRESULT; stdcall;
   Function RemoveScript(wIndex: Word): HRESULT; stdcall;
 end;

 Type
 IWMHeaderInfo2 = interface(IWMHeaderInfo)
 ['{15CF9781-454E-482e-B393-85FAE487A810}']
   Function GetCodecInfoCount(out pcCodecInfos: LongWord): HRESULT; stdcall;
   Function GetCodecInfo(wIndex: LongWord; var pcchName: Word;
    pwszName: PWideChar; var pcchDescription: Word;
    pwszDescription: PWideChar; out pCodecType: WMT_CODEC_INFO_TYPE;
     var pcbCodecInfo: Word;pbCodecInfo: PBYTE): HRESULT; stdcall;
 end;

 Type
 IWMHeaderInfo3 = interface(IWMHeaderInfo2)
 ['{15CC68E3-27CC-4ecd-B222-3F5D02D80BD5}']
   Function GetAttributeCountEx(wStreamNum: Word; out pcAttributes: Word): HRESULT; stdcall;
   Function GetAttributeIndices(wStreamNum: Word; pwszName: PWideChar;
     pwLangIndex: PWORD;pwIndices: PWORD; var pwCount: Word): HRESULT; stdcall;
  Function GetAttributeByIndexEx(wStreamNum: Word; wIndex: Word;pwszName: PWideChar;
    var  pwNameLen: Word; out  pType: TWMTAttrDataType; out  pwLangIndex: Word;
  pValue: PBYTE; var pdwDataLength: LongWord): HRESULT; stdcall;
   Function ModifyAttribute(wStreamNum: Word; wIndex: Word; Type_: TWMTAttrDataType;
     wLangIndex: Word; pValue: PBYTE; dwLength: LongWord): HRESULT; stdcall;
   Function AddAttribute(wStreamNum: Word; pszName: PWideChar;
     out pwIndex: Word; Type_: TWMTAttrDataType; wLangIndex: Word;
     pValue: PBYTE; dwLength: LongWord): HRESULT; stdcall;
   Function DeleteAttribute(wStreamNum, wIndex: Word): HRESULT; stdcall;
   Function AddCodecInfo(pwszName: PWideChar; pwszDescription: PWideChar;
     codecType: WMT_CODEC_INFO_TYPE; cbCodecInfo: Word;
     pbCodecInfo: PBYTE): HRESULT; stdcall;
 end;