unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, id3v2;

type
  TForm1 = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    ID3title: TEdit;
    ID3artist: TEdit;
    ID3album: TEdit;
    ID3year: TEdit;
    ID3genre: TEdit;
    Label6: TLabel;
    ID3track: TEdit;
    OpenDialog1: TOpenDialog;
    LoadButton: TButton;
    SaveButton: TButton;
    Label7: TLabel;
    ID3Comment: TEdit;
    procedure LoadButtonClick(Sender: TObject);
    procedure SaveButtonClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  myTag: Tid3v2Tag;


implementation

{$R *.DFM}

procedure TForm1.LoadButtonClick(Sender: TObject);
var
tempStr : string;
tempInt : word;
myCOMM : COMM;
begin
if OpenDialog1.execute then
 begin
 tempInt := myTag.loadFromFile(OpenDialog1.filename, 0);
 if (tempInt > 255) then
  showMessage(format('Error #%d! Could not load Tag!',[tempInt])) else
   begin
   myTag.getAsciiText('TIT2', tempStr); //Get Song Title
   ID3title.text := tempStr;
   myTag.getAsciiText('TPE1', tempStr); //Get Artist Name
   ID3artist.text := tempStr;
   myTag.getAsciiText('TALB', tempStr); //Get Album Name
   ID3album.text := tempStr;
   myTag.getAsciiText('TYER', tempStr); //Get Release Year
   ID3year.text := tempStr;
   myTag.getAsciiText('TCON', tempStr); //Get Genre
   ID3genre.text := tempStr;
   myTag.getAsciiText('TRCK', tempStr); //Get Track #
   ID3track.text := tempStr;
   myTag.getCOMM(myCOMM, ''); //Get basic comment (no description)
   ID3Comment.text := myCOMM.body;
   end;
 end;
end;

procedure TForm1.SaveButtonClick(Sender: TObject);
var
tempInt : word;
myCOMM : COMM;
begin
myTag.setAsciiText('TIT2', ID3title.text); //Set Song Title
myTag.setAsciiText('TPE1', ID3artist.text); //Set Artist Name
myTag.setAsciiText('TALB', ID3album.text); //Set Album Name
myTag.setAsciiText('TYER', ID3year.text); //Set Release Year
myTag.setAsciiText('TCON', ID3genre.text); //Set Genre
myTag.setAsciiText('TRCK', ID3track.text); //Set Track #
myCOMM.encoding := etASCII;
myCOMM.language := 'ENG';
myCOMM.description := '';
myCOMM.body := ID3comment.text;
myTag.setCOMM(myCOMM, myCOMM.description);
tempInt := myTag.saveToFile;
if (tempInt > 255) then
 showMessage(format('Error #%d! Could not save Tag!',[tempInt]));
end;

initialization
myTag := Tid3v2tag.create;

finalization
if myTag <> nil then
 myTag.free;

end.

