//********************************************************************************************************************************
//*                                                                                                                              *
//*     Filesystem Dialogs  3delite 2006-2007                                                                                   *
//*     See FilesystemDialogs.txt for details                                                                                    *
//*                                                                                                                              *
//* Two licenses are available if you like this library:                                                                         *
//* Shareware License: 50 Euros                                                                                                  *
//* Commercial License: 500 Euros                                                                                                *
//*                                                                                                                              *
//*     http://www.3delite.hu/Object Pascal Developer Resources/filesystemdialogs.html                                           *
//*                                                                                                                              *
//* If you have any questions or enquiries please mail: 3delite@3delite.hu                                                       *
//*                                                                                                                              *
//* Good coding! :)                                                                                                              *
//* 3delite                                                                                                                      *
//********************************************************************************************************************************

unit FilesystemDialogsDefs;

interface

Uses
  SysUtils, Classes, Windows, Dialogs, Forms, Graphics;

const
  //* .dll file names
  FILENAME_DLL_FD                       = 'FilesystemDialogs.dll';
  FILENAME_DLL_FD_DISABLED              = 'FilesystemDialogs.Disabled dll';
  FILENAME_DLL_VRM                      = 'VangaRengiMangaro.dll';

  //* Exported function names
  NAME_FD_OpenDialog                    = 'FilesystemDialogs_OpenDialog';
  NAME_FD_SaveDialog                    = 'FilesystemDialogs_SaveDialog';
  NAME_FD_FolderDialog                  = 'FilesystemDialogs_FolderDialog';
  NAME_FD_Settings                      = 'FilesystemDialogs_SettingsWindow';

  NAME_FD_GetOpenFileNameA              = 'FilesystemDialogs_GetOpenFileNameA';
  NAME_FD_GetOpenFileNameW              = 'FilesystemDialogs_GetOpenFileNameW';
  NAME_FD_GetSaveFileNameA              = 'FilesystemDialogs_GetSaveFileNameA';
  NAME_FD_GetSaveFileNameW              = 'FilesystemDialogs_GetSaveFileNameW';

  NAME_FD_InitTOpenDialogParams         = 'FilesystemDialogs_InitTOpenDialogParams';
  NAME_FD_FreeTOpenDialogParams         = 'FilesystemDialogs_FreeTOpenDialogParams';
  NAME_FD_InitTOpenDialogResults        = 'FilesystemDialogs_InitTOpenDialogResults';
  NAME_FD_FreeTOpenDialogResults        = 'FilesystemDialogs_FreeTOpenDialogResults';

  NAME_VRM_GetPrevProcs                 = 'VangaRengiMangaro_GetPrevProcs';

  //* Registry keys
  STR_REG_FD_SETTINGS                   = 'Software\3delite\Filesystem Dialogs';
  STR_REG_FD_FONT_SETTINGS              = 'Font settings';
  STR_REG_FD_DIALOG_SETTINGS            = 'App settings';
  STR_REG_FD_DIALOG_LASTCONFIG          = 'Last config';
  STR_REG_FD_FAVORITE_FOLDERS           = 'Favourite folders';
  STR_REG_FD_LAST_FOLDERS               = 'Last visited folders';

  //* Global settings
  STR_REG_USE_LAST_FOLDER               = 'Always use last used folder';
  STR_REG_SINGLE_SETUP                  = 'Single setup';
  STR_REG_PRECISION                     = 'Double file size precision';
  STR_REG_READ_CREATED_FOLDER           = 'Automatically go into newly created folder';
  STR_REG_SAVE_SETTINGS_ON_CANCEL       = 'Save settings on Cancel';
  STR_REG_LANCZOS_FOR_THUMBNAILS        = 'Thumbnails use Lanczos filter';
  STR_REG_THUMBNAILS_FOR_DIRS           = 'Thumbnails for dirs';
  STR_REG_THUMBNAILS_FOR_DIR_AUDIO      = 'Thumbnails for dirs with audio';
  STR_REG_THUMBNAILS_FOR_AUDIOFILES     = 'Thumbnails for recognised audio files';
  STR_REG_THUMBNAILS_FOR_TEXTFILES      = 'Thumbnails for TEXT files';
  STR_REG_THUMBNAILS_BCKG_COLOR         = 'Thumbnails use custom color for non image thumbnail background';
  STR_REG_THUMBNAILS_BCKG_COLOR_V       = 'Thumbnails custom color for non image thumbnail background';
  STR_REG_THUMBNAILS_BCKG_PIC_COLOR     = 'Thumbnails use custom color for picture thumbnail background';
  STR_REG_THUMBNAILS_BCKG_PIC_COLOR_V   = 'Thumbnails custom color for picture thumbnail background';
  STR_REG_THUMBNAILS_FONT_COLOR         = 'Thumbnails use custom color for fonts';
  STR_REG_THUMBNAILS_FONT_COLOR_FOLDER_V = 'Thumbnails custom color for folder name font';
  STR_REG_THUMBNAILS_FONT_COLOR_FILE_V  = 'Thumbnails custom color for file name font';
  STR_REG_THUMBNAILS_FONT_COLOR_EXT_V   = 'Thumbnails custom color for file extension font';
  STR_REG_THUMBNAILS_ZOOM_X2            = 'Thumbnails zoom small images x2';
  STR_REG_THUMBNAILS_FOLDER_CAP_CENTER  = 'Thumbnails center folder names on folder thumbnails';
  STR_REG_THUMBNAILS_AVOID_EXIF         = 'Thumbnails do not use EXIF thumbnails';
  STR_REG_THREAD_THUMBNAILER            = 'Thumbnailer threaded';
  STR_REG_THUMBNAILS_WIDTH              = 'Thumbnails width';
  STR_REG_THUMBNAILS_HEIGHT             = 'Thumbnails height';
  STR_REG_THUMBNAILS_SIZE_PRESET        = 'Thumbnails dimensions preset';
  STR_REG_THUMBNAILS_SAMPLE_COLOR_L     = 'Thumbnails audio sample color left channel';
  STR_REG_THUMBNAILS_SAMPLE_COLOR_R     = 'Thumbnails audio sample color right channel';
  STR_REG_THUMBNAILS_SAMPLE_COLOR_B     = 'Thumbnails audio sample color background';
  STR_REG_THUMBNAILS_SAMPLE_AA          = 'Thumbnails audio sample antialiasing level';
  STR_REG_SAVE_SESC                     = 'Save SESC';
  STR_REG_FS_FORCE_EXTCASE              = 'Force extension case';
  STR_REG_FS_FORCE_EXTCASEL             = 'Force extension to uppercase';
  STR_REG_FS_FORCE_EXTCASEU             = 'Force extension to lowercase';
  STR_REG_ALLOW_GIFANDTIFFLZW           = 'Allow GIF and TIFF LZW decompression';
  STR_REG_INACTIVE_TREEVIEW             = 'Inactive tree view until first touch';
  STR_REG_OMIT_FILE_EXT                 = 'Omit file extensions';
  STR_REG_ID3_DESCRIPTION               = 'Display ID3 in Description';
  STR_REG_SETTINGS_TOP                  = 'Settings window top';
  STR_REG_SETTINGS_LEFT                 = 'Settings window left';
  STR_REG_SETTINGS_WIDTH                = 'Settings window width';
  STR_REG_SETTINGS_HEIGHT               = 'Settings window height';
  STR_REG_SETTINGS_PAGE_INDEX           = 'Settings page index';
  STR_REG_SETTINGS_PAGE_THUMBS_INDEX    = 'Settings thumbs page index';
  STR_REG_SETTINGS_PAGE_PREFS_INDEX     = 'Settings preferences page index';
  STR_REG_RECENT_FOLDER_COUNT           = 'Number of recent folders to remember';
  STR_REG_SHOW_SCROLLBAR_RECENT         = 'Show Scrollbars with Recent Folder and Drives and Favorites list';
  STR_REG_SHOW_SCROLLBAR_TREEVIEW       = 'Show Scrollbars on Tree View';
  STR_REG_THUMBNAILS_CACHED_GRAPHICAL   = 'Cache the graphical thumbnails';
  STR_REG_THUMBNAILS_CACHED             = 'Cache the thumbnails';
  STR_REG_SETTINGS_DISPLAY_EXTS_CONVERTED = 'Display file extensions converted';
  STR_REG_SEC_VIEWER                    = 'Enable secondary display full screen viewer';
  STR_REG_SEC_VIEWER_SPECIFY            = 'Secondary display full screen viewer specify display';
  STR_REG_SEC_VIEWER_MONITOR            = 'Secondary display full screen viewer monitor number';
  STR_REG_SEC_VIEWER_AUDIO              = 'Secondary display full screen audio viewer';
  STR_REG_SEC_VIEWER_AUDIO_NO_STATUS    = 'Secondary display full screen audio viewer don''t show progress';
  STR_REG_SEC_VIEWER_AUDIO_NO_INFO      = 'Secondary display full screen audio viewer don''t show audio information';
  STR_REG_SEC_VIEWER_AUDIO_AA           = 'Secondary display full screen audio viewer antialiasing level';
  STR_REG_SEC_VIEWER_PICTURE            = 'Secondary display full screen picture viewer';
  STR_REG_SEC_VIEWER_PICTURE_RESAMPLER  = 'Secondary display full screen picture viewer resampler filter';
  STR_REG_SEC_VIEWER_HTML               = 'Secondary display full screen HTML viewer';
  STR_REG_SEC_VIEWER_TEXT_RTF           = 'Secondary display full screen TEXT & RTF viewer';
  STR_REG_BALLOON_ON_OFF_GLOBAL         = 'Balloon hints enabled (global)';
  STR_REG_BALLOON_IN_LISTER             = 'Show balloon hints in Lister mode';
  STR_REG_BALLOON_IN_THUMBNAIL          = 'Show balloon hints in Thumbnail mode';
  STR_REG_BALLOON_HINT_TIMEOUT          = 'Balloon hint time-out';
  STR_REG_BALLOON_THUMBNAILS            = 'Display thumbnails on balloon hints';
  STR_REG_BASS_DONTINIT                 = 'Do not initialize BASS';
  STR_REG_TYPES_BROWSER                 = 'Web browser file extension types';
  STR_REG_TYPES_AUDIO                   = 'Audio file extension types';
  STR_REG_TYPES_TEXT                    = 'Text file extension types';
  STR_REG_BALLOON_IN_DRIVES             = 'Show balloon hints on Drives & Favs and Recent Folder list';
  STR_REG_GRID_LINES                    = 'Enable grid lines';
  STR_REG_URL_DECODE_FILENAMES          = 'Automatically decode URL encoded file names';
  STR_REG_UPPERCASE_FIRST_LETTER_FOR_FILENAMES = 'Automatically convert first letter in file names to upper case';
  STR_REG_UNDERSCORES_2_SPACE_FOR_FILENAMES = 'Automatically convert underscores to spaces in file names';
  STR_REG_RECENT_FILES_COUNT            = 'Number of recent files to remember';
  STR_REG_DONTDISAPLAY_TFDDB            = 'Do not show "Thumbs Filesystem Dialogs.db" file';
  STR_REG_FILENAME_TEMPLATE             = 'Filename template';
  STR_REG_RECENT_FILES_DEL_INVALID      = 'Automatically delete invalid recent link files';
  STR_REG_THUMBNAILS_FOR_AUDIOFILES_APIC = 'Thumbnails for recognised audio files from APIC';
  STR_REG_THUMBNAILER_TEXT_ZOOM         = 'Zoom percent value for text thumbnails';
  STR_REG_SEC_VIEWER_HTML_UNKNOWN_TYPES = 'Secondary display full screen HTML viewer display unknown types too';
  STR_REG_FILENAME_AUTOMATIC_RENAME     = 'Automatically rename existing save file names';
  STR_REG_NO_CDN_TYPECHANGE             = 'Do not send CDN_TYPECHANGE messages';
  STR_REG_LISTER_HAS_THE_FOCUS          = 'After window had appeared the Lister has the input focus';
  STR_REG_BALLOON_NO_FILENAME_FOCUS     = 'Do not show Balloon Hints when file name combo box has focus';

  //* Default file types
const
  FILE_TYPES_DEF_FILTER                 = 'Text files|*.txt;*.log;*.ini;*.cfg;*.text|'
                                        + 'Picture files|*.jpg;*.bmp;*.png;*.gif;*.jpeg;*.pcx;*.psd;*.iff|'
                                        + 'Audio files|*.mp3;*.flac;*.wav;*.mp2;*.aif;*.mp4;*.ac3;*.mpc;*.mpa;*.mp1|'
                                        + 'Document files|*.doc;*.rtf;*.pdf;*.txt;*.log|'
                                        + 'Text system files|*.ini;*.cfg;*.bat;*.cmd;*.log|'
                                        + 'All files|*.*'
                                        ;

  //* Viewer default file types
  FILE_TYPES_BROWSER                    = 'HTM, HTML, MHT, SWF, URL, XML';
  FILE_TYPES_AUDIO                      = 'WAV, AIF, AIFF, MP3, MP2, MP1, MPA, OGG, MOD, MO3, IT, XM, S3M, MTM, UMX';
  FILE_TYPES_TEXT                       = 'TEXT, TXT, LOG';

  //* Localization
  STR_REG_LOCALIZATION_FILE             = 'Localization file';

  //* Filenames
  FILENAME_DEBUG                        = 'C:\Filesystem Dialogs debug.log';

  WWW_FILESYSTEMDIALOGS_HELP 		    = 'http://www.3delite.hu/Object%20Pascal%20Developer%20Resources/filesystemdialogs.html';

  //* Internal max. path size                       7800 bytes (30)
  FD_MAX_PATH                           = MAX_PATH * 30;

const
  cColName                          = 0;
  cColSize                          = 1;
  cColType                          = 2;
  cColCreated                       = 3;
  cColModified                      = 4;
  cColAccessed                      = 5;

const
  STR_THUMB_Sampling                = ' Sampling... ';
  STR_THUMB_Generating              = ' Generating...';
  STR_THUMB_SESC_Saving             = 'Writing cache...';

  HEADER_COLUMN_NAME                = 'Name';
  HEADER_COLUMN_SIZE                = 'Size';
  HEADER_COLUMN_DESCRIPTION         = 'Description';
  HEADER_COLUMN_CREATION_TIME       = 'Creation Time';
  HEADER_COLUMN_LAST_WRITE_TIME     = 'Last Write Time';
  HEADER_COLUMN_LAST_ACCES_TIME     = 'Last Access Time';

const
  //* Blue for XP's white background
  THUMBNAIL_COLOR_L = $FF0000FF;
  THUMBNAIL_COLOR_R = $FF000064;

  //* Abs(0) = none
  THUMBNAIL_COLOR_B = $00000000;

const
  THUMBNAIL_COLOR_1L = $FFFF8000;
  THUMBNAIL_COLOR_1R = $FFFFFF00;
  THUMBNAIL_COLOR_1B = $00000000;

  THUMBNAIL_COLOR_2L = $FFFFFF00;
  THUMBNAIL_COLOR_2R = $FF00FF00;
  THUMBNAIL_COLOR_2B = $00000000;

  THUMBNAIL_COLOR_3L = $FF0000FF;
  THUMBNAIL_COLOR_3R = $FF00FF00;
  THUMBNAIL_COLOR_3B = $00000000;

  THUMBNAIL_COLOR_4L = $FFFF8000;
  THUMBNAIL_COLOR_4R = $FF00FF00;
  THUMBNAIL_COLOR_4B = $00000000;

const
  THUMBNAIL_COLOR_FOLDER_NAME   = $55222222;
  THUMBNAIL_COLOR_FILE_NAME     = $FF000000; //clBlack32;
  THUMBNAIL_COLOR_EXTENSION     = $FF0000FF; //clBlue32;

const
  PROTOCOL_NO                       = 0;
  PROTOCOL_HTTP                     = 1;
  PROTOCOL_FTP                      = 2;

const
  THUMB_FRAME_SIZE                  = 3 * 2;

const
  //* Thumbnail text anti aliasing level 0-4 (affects speed)
  THUMB_AA_LEVEL_FOLDER_NAME        = 2;
  THUMB_AA_LEVEL_FILE_NAME          = 3;

const
  THUMBNAILER_WEBBROWSER_WIDTH      = 1024;
  THUMBNAILER_WEBBROWSER_HEIGHT     = 822;

//* from Dialogs.pas
type
  TOpenOption = (ofReadOnly, ofOverwritePrompt, ofHideReadOnly, ofNoChangeDir, ofShowHelp, ofNoValidate, ofAllowMultiSelect, ofExtensionDifferent,
    ofPathMustExist, ofFileMustExist, ofCreatePrompt, ofShareAware, ofNoReadOnlyReturn, ofNoTestFileCreate, ofNoNetworkButton, ofNoLongNames,
    ofOldStyleDialog, ofNoDereferenceLinks, ofEnableIncludeNotify, ofEnableSizing, ofDontAddToRecent, ofForceShowHidden, ofNotModal, ofNoClose,
    ofIntegrate, ofStayOnTop);

  TOpenOptions = set of TOpenOption;

//* from CommDlg.pas
type
  OFNHookProc = function(Wnd: HWND; Msg: UINT; wParam: WPARAM; lParam: LPARAM): UINT; stdcall;

type
  t_SHGetImageList = function(iImageList: Integer; riid: Integer; ppv: Pointer): HResult;

type
  tagOFN = packed record
    lStructSize: DWORD;
    hWndOwner: HWND;
    hInstance: HINST;
    lpstrFilter: PAnsiChar;
    lpstrCustomFilter: PAnsiChar;
    nMaxCustFilter: DWORD;
    nFilterIndex: DWORD;
    lpstrFile: PAnsiChar;
    nMaxFile: DWORD;
    lpstrFileTitle: PAnsiChar;
    nMaxFileTitle: DWORD;
    lpstrInitialDir: PAnsiChar;
    lpstrTitle: PAnsiChar;
    Flags: DWORD;
    nFileOffset: Word;
    nFileExtension: Word;
    lpstrDefExt: PAnsiChar;
    lCustData: LPARAM;
    lpfnHook: OFNHookProc;
    lpTemplateName: PAnsiChar;
    pvReserved: Pointer;
    dwReserved: DWORD;
    FlagsEx: DWORD;
  end;

type
  TOpenOptionEx = (ofExNoPlacesBar);
  TOpenOptionsEx = set of TOpenOptionEx;

type
  TOFNOTIFY = packed record
    hdr: TNMHdr;
    lpOFN: Pointer; //tagOFN;
    pszFile: PAnsiChar;
  end;

type
  TCallData = record
    CalledFromComdlg32: Boolean;
    CalledUnicode: Boolean;
    UseBackupedStruct: Boolean;
  end;

const
  {$EXTERNALSYM OFN_READONLY}
  OFN_READONLY = $00000001;
  {$EXTERNALSYM OFN_OVERWRITEPROMPT}
  OFN_OVERWRITEPROMPT = $00000002;
  {$EXTERNALSYM OFN_HIDEREADONLY}
  OFN_HIDEREADONLY = $00000004;
  {$EXTERNALSYM OFN_NOCHANGEDIR}
  OFN_NOCHANGEDIR = $00000008;
  {$EXTERNALSYM OFN_SHOWHELP}
  OFN_SHOWHELP = $00000010;
  {$EXTERNALSYM OFN_ENABLEHOOK}
  OFN_ENABLEHOOK = $00000020;
  {$EXTERNALSYM OFN_ENABLETEMPLATE}
  OFN_ENABLETEMPLATE = $00000040;
  {$EXTERNALSYM OFN_ENABLETEMPLATEHANDLE}
  OFN_ENABLETEMPLATEHANDLE = $00000080;
  {$EXTERNALSYM OFN_NOVALIDATE}
  OFN_NOVALIDATE = $00000100;
  {$EXTERNALSYM OFN_ALLOWMULTISELECT}
  OFN_ALLOWMULTISELECT = $00000200;
  {$EXTERNALSYM OFN_EXTENSIONDIFFERENT}
  OFN_EXTENSIONDIFFERENT = $00000400;
  {$EXTERNALSYM OFN_PATHMUSTEXIST}
  OFN_PATHMUSTEXIST = $00000800;
  {$EXTERNALSYM OFN_FILEMUSTEXIST}
  OFN_FILEMUSTEXIST = $00001000;
  {$EXTERNALSYM OFN_CREATEPROMPT}
  OFN_CREATEPROMPT = $00002000;
  {$EXTERNALSYM OFN_SHAREAWARE}
  OFN_SHAREAWARE = $00004000;
  {$EXTERNALSYM OFN_NOREADONLYRETURN}
  OFN_NOREADONLYRETURN = $00008000;
  {$EXTERNALSYM OFN_NOTESTFILECREATE}
  OFN_NOTESTFILECREATE = $00010000;
  {$EXTERNALSYM OFN_NONETWORKBUTTON}
  OFN_NONETWORKBUTTON = $00020000;
  {$EXTERNALSYM OFN_NOLONGNAMES}
  OFN_NOLONGNAMES = $00040000;
  {$EXTERNALSYM OFN_EXPLORER}
  OFN_EXPLORER = $00080000;
  {$EXTERNALSYM OFN_NODEREFERENCELINKS}
  OFN_NODEREFERENCELINKS = $00100000;
  {$EXTERNALSYM OFN_LONGNAMES}
  OFN_LONGNAMES = $00200000;
  {$EXTERNALSYM OFN_ENABLEINCLUDENOTIFY}
  OFN_ENABLEINCLUDENOTIFY = $00400000;
  {$EXTERNALSYM OFN_ENABLESIZING}
  OFN_ENABLESIZING = $00800000;
  { #if (_WIN32_WINNT >= 0x0500) }
  {$EXTERNALSYM OFN_DONTADDTORECENT}
  OFN_DONTADDTORECENT = $02000000;
  {$EXTERNALSYM OFN_FORCESHOWHIDDEN}
  OFN_FORCESHOWHIDDEN = $10000000;    // Show All files including System and hidden files
  { #endif // (_WIN32_WINNT >= 0x0500) }

  { FlagsEx Values }
  { #if (_WIN32_WINNT >= 0x0500) }
  {$EXTERNALSYM OFN_EX_NOPLACESBAR}
  OFN_EX_NOPLACESBAR = $00000001;
  { #endif // (_WIN32_WINNT >= 0x0500) }

{ Return values for the registered message sent to the hook function
  when a sharing violation occurs.  OFN_SHAREFALLTHROUGH allows the
  filename to be accepted, OFN_SHARENOWARN rejects the name but puts
  up no warning (returned when the app has already put up a warning
  message), and OFN_SHAREWARN puts up the default warning message
  for sharing violations.

  Note:  Undefined return values map to OFN_SHAREWARN, but are
         reserved for future use. }

  {$EXTERNALSYM OFN_SHAREFALLTHROUGH}
  OFN_SHAREFALLTHROUGH = 2;
  {$EXTERNALSYM OFN_SHARENOWARN}
  OFN_SHARENOWARN = 1;
  {$EXTERNALSYM OFN_SHAREWARN}
  OFN_SHAREWARN = 0;

const

  {$EXTERNALSYM WM_USER}
  WM_USER             = $0400;

  {$EXTERNALSYM CDN_FIRST}
  CDN_FIRST = -601;
  {$EXTERNALSYM CDN_LAST}
  CDN_LAST = -699;

{ Notifications when Open or Save dialog status changes }

  {$EXTERNALSYM CDN_INITDONE}
  CDN_INITDONE = CDN_FIRST - 0;
  {$EXTERNALSYM CDN_SELCHANGE}
  CDN_SELCHANGE = CDN_FIRST - 1;
  {$EXTERNALSYM CDN_FOLDERCHANGE}
  CDN_FOLDERCHANGE = CDN_FIRST - 2;
  {$EXTERNALSYM CDN_SHAREVIOLATION}
  CDN_SHAREVIOLATION = CDN_FIRST - 3;
  {$EXTERNALSYM CDN_HELP}
  CDN_HELP = CDN_FIRST - 4;
  {$EXTERNALSYM CDN_FILEOK}
  CDN_FILEOK = CDN_FIRST - 5;
  {$EXTERNALSYM CDN_TYPECHANGE}
  CDN_TYPECHANGE = CDN_FIRST - 6;
  {$EXTERNALSYM CDN_INCLUDEITEM}
  CDN_INCLUDEITEM = CDN_FIRST - 7;

  {$EXTERNALSYM CDM_FIRST}
  CDM_FIRST = WM_USER + 100;
  {$EXTERNALSYM CDM_LAST}
  CDM_LAST = WM_USER + 200;

{ Messages to query information from the Open or Save dialogs }

{ lParam = pointer to text buffer that gets filled in
  wParam = max number of characters of the text buffer (including NULL)
  return = < 0 if error; number of characters needed (including NULL) }

  {$EXTERNALSYM CDM_GETSPEC}
  CDM_GETSPEC = CDM_FIRST + 0;

{ lParam = pointer to text buffer that gets filled in
  wParam = max number of characters of the text buffer (including NULL)
  return = < 0 if error; number of characters needed (including NULL) }

  {$EXTERNALSYM CDM_GETFILEPATH}
  CDM_GETFILEPATH = CDM_FIRST + 1;

{ lParam = pointer to text buffer that gets filled in
  wParam = max number of characters of the text buffer (including NULL)
  return = < 0 if error; number of characters needed (including NULL) }

  {$EXTERNALSYM CDM_GETFOLDERPATH}
  CDM_GETFOLDERPATH = CDM_FIRST + 2;

{ lParam = pointer to ITEMIDLIST buffer that gets filled in
  wParam = size of the ITEMIDLIST buffer
  return = < 0 if error; length of buffer needed }

  {$EXTERNALSYM CDM_GETFOLDERIDLIST}
  CDM_GETFOLDERIDLIST = CDM_FIRST + 3;

{ lParam = pointer to a string
  wParam = ID of control to change
  return = not used }

  {$EXTERNALSYM CDM_SETCONTROLTEXT}
  CDM_SETCONTROLTEXT = CDM_FIRST + 4;

{ lParam = not used
  wParam = ID of control to change
  return = not used }

  {$EXTERNALSYM CDM_HIDECONTROL}
  CDM_HIDECONTROL = CDM_FIRST + 5;

{ lParam = pointer to default extension (no dot)
  wParam = not used
  return = not used }

  {$EXTERNALSYM CDM_SETDEFEXT}
  CDM_SETDEFEXT = CDM_FIRST + 6;

//* Filesystem Dialogs messages
const

  //* Pointer to TOpenDialogResults is in wParam
  //* Pointer to TOpenDialogParams is in lParam
  //* You get the messages in the hookproc and to the specified Parent window handle
  FDM_BASE              = 2 * WM_USER + 1;

  //* Filesystem Dialogs results message
  FDM_RESULTS           = FDM_BASE + 1;

  //* Load settings
  FDM_LOADSETTINGS      = FDM_BASE + 2;

  //* Free memory that you have allocated for the dialog('s params, results)
  FDM_FREEMEM           = FDM_BASE + 3;

  //* The dialog form is closing
  FDM_CLOSING           = FDM_BASE + 4;

  //* The dialog form's window handle in wParam
  //* Pointer to TOpenDialogParams is in lParam
  FDM_WINDOW_HANDLE     = FDM_BASE + 5;

  //* Realing the integrated form to the parent
  FDM_REALIGN_INTEGRATED_WINDOW = FDM_BASE + 6;  

//* Thumbs.db structs !??? (under construction)
//* If anybody has information about using the file... don't hasitate!
{
type
  TCatalogHeader = record
    num1: short;
    num2: short;
    thumbCount: Integer;
    thumbWidth: Integer;
    thumbHeight: Integer;
  end;

type
  TCatalogItem = record
    num1: Integer;
    itemID: Integer;
    num3: short;
    num4: short;
    num5: short;
    num6: short;
    filename: PChar;
    num7: short;
  end;
}

//* Filesystem dialogs types
type
  TFSDialogType = (fsdtOpenDialog, fsdtSaveDialog, fsdtFolderDialog);

//* Filesystem dialog Open file/Save file dialog Params
type
  TOpenDialogParams = record
    DefaultExt: PChar;          //* Default extension
    FileName: PChar;            //* Default file name for Open/Save and Initial dir
    Filters: PChar;             //* Filters eg.: 'Image files (*.bmp,*.jpg)|*.bmp;*.jpg|All files|*.*'
    FilterIndex: Integer;       //* Filter to use default, 1-first, 2-second...
    HelpContext: Integer;       //* Help context (not yet implemented)
    InitialDir: PChar;          //* Initial folder, this is extracted first from FileName, if no FileName specified settings are used to decide which folder to use
    Options: TOpenOptions;      //* Dialog options (not all implemented so far)
    OptionsEx: TOpenOptionsEx;  //* Extra Dialog options (not implemented, probably never will)
    Title: PChar;               //* Title to display as window's caption
    ParentWindow: HWND;         //* Parent window handle (needed for HookProc)
    DialogGUID: TGUID;          //* Specifically identificate the dialog (separate dialogs inside an application - you can get the same dialog always with this flag)
    HookProc: OFNHookProc;      //* Hookproc (There are two: 1. for not modal mode result, and 2. for filter change event (avoid using it) - ParentWindow handle is also needed)
    DialogType: TFSDialogType;  //* Type of the dialog: Open/Save/Folder
    AllowTIFFLZW: LongBool;     //* Allow LZW coded TIF image thumbnails (using these formats requires a license)
    //FileSize: Int64;			//* Estimated file size (will warn if won't fit in the selected directory before performing any saving)
    //MD5: String;				//* MD5 value of the file to save (compare to exisisting files)
    //User: Pointer;            //* User variable
  end;

//* Filesystem dialog result
type
  TOpenDialogResults = record
    Successfull: BOOL;          //* True: User pressed the Open/Save button or double-clicked on a file, False: User pressed Cancel or closed the window, or error (there is fallback to comdlg32.dll though)
    FileName: PChar;            //* The filename with full path the user selected (only one) ending with a double null: "C:\Dir\Data.txt" + #0#0
    FileNameSize: Int64;        //* FileName size in bytes (should be always at least MAX_PATH)
    FileCount: Cardinal;        //* Number of files, if user selected multiple files then FileCount > 1
    FileNames: PChar;           //* List of files in format "C:\Dir\Data.txt" + #0 + "D:\Folder\DataX.txt" separated by null characters ending with a double null
    FileNamesSize: Int64;       //* FileNames size in bytes (it's up to you to validate last entry if all selected filenames don't fit into the FileNames - but always check with FileExists())
    FilterIndex: Integer;       //* Filter's index the user selected 1-first, 2-second, etc...
  end;

//* Filesystem Dialogs file data (used internally)
type
  TFileData = class
    FileName: String;
    ItemName: String;
    IsFolder: Boolean;
    Size: Int64;
    CreationTime: TFileTime;
    LastWriteTime: TFileTime;
    LastAccessTime: TFileTime;
    ThumbnailIndex: Int64;
    Width: Int64;
    Height: Int64;
    Description: String;
    ID3String: String;
    IconHandle: HICON;
  public
    {$IFDEF _FILESYSTEM_DIALOGS_COMPILE}
    fSolvedFileName: String;
    fDelBadLink: Boolean;
    fWinHandle: THandle;
    function SolvedFileName: String;
    {$ELSE}
    SolvedFileName: String;
    {$ENDIF}
    Destructor Destroy; override;
  end;

//* Filesystem Dialogs settings class
type
  TFilesystemDialogsSettings = class(TComponent)
  private
  public
    UseLastFolder: Boolean;
    SingleSetup: Boolean;
    Precision: Boolean;
    Daynames: Boolean;
    AutoGoIntoCreatedFolder: Boolean;
    SaveSettingsOnCancel: Boolean;
    LanczosFilterForThumbnails: Boolean;
    ThumbnailsForDirs: Boolean;
    ThumbnailsForDirsAudio: Boolean;
    ThumbnailsForAudioFiles: Boolean;
    ThumbnailsForTextFiles: Boolean;
    ThumbnailerThreading: Boolean;
    ThumbnailsUseCustomBckgColor: Boolean;
    ThumbnailsCustomBckgColor: Cardinal;
    ThumbnailsPictureUseCustomBckgColor: Boolean;
    ThumbnailsPictureCustomBckgColor: Cardinal;
    ThumbnailsUseCustomFontColor: Boolean;
    ThumbnailsUseFolderFontColor: Cardinal;
    ThumbnailsUseFileNameColor: Cardinal;
    ThumbnailsUseExtColor: Cardinal;
    ThumbnailsSmallZoomx2: Boolean;
    ThumbnailsCenterFolderCaps: Boolean;
    ThumbnailsAvoidEXIF: Boolean;
    ThumbnailsWidth: Integer;
    ThumbnailsHeight: Integer;
    ThumbnailsSizePreset: Integer;
    ThumbnailsSampleColorL: Cardinal;
    ThumbnailsSampleColorR: Cardinal;
    ThumbnailsSampleColorB: Cardinal;
    ThumbnailsSampleAALEvel: Cardinal;
    ThumbnailsCache: Boolean;
    SaveSESC: Boolean;
    AllowTIFFLZW: Boolean;
    ForceExtCase: Boolean;
    ForceExtCaseUpper: Boolean;
    ForceExtCaseLower: Boolean;
    Font: TFont;
    InactiveTreeViewUntilFirstTouch: Boolean;
    OmitFileExt: Boolean;
    DisplayID3InDescription: Boolean;
    SettingsWindowPosition: TPoint;
    SettingsPageIndex: Integer;
    SettingsPageThumbsIndex: Integer;
    SettingsPagePrefsIndex: Integer;
    RecentFolderCount: Int64;
    RecentFileCount: Int64;
    ShowScrollbarsRecent: Boolean;
    ShowScrollbarsTreeView: Boolean;
    ConvertDisplayExtensions: Boolean;
    UseSecondaryViewer: Boolean;
    SecondaryViewerSpecified: Boolean;
    SecondaryViewerMonitorNo: Integer;
    SecondaryViewerAudio: Boolean;
    SecondaryViewerAudioNoProgress: Boolean;
    SecondaryViewerAudioNoInfo: Boolean;
    SecondaryViewerAudioAA: Integer;
    SecondaryViewerPicture: Boolean;
    SecondaryViewerPictureResampler: Integer;
    SecondaryViewerHTML: Boolean;
    SecondaryViewerHTMLAllFiles: Boolean;
    SecondaryViewerTEXTRTF: Boolean;
    BalloonInLister: Boolean;
    BalloonInThumbnailMode: Boolean;
    BalloonHintTimeOut: Integer;
    BalloonHasThumbs: Boolean;
    BASSDontInit: Boolean;
    TypesBrowser: String;
    TypesAudio: String;
    TypesText: String;
    BalloonInDrives: Boolean;
    EnableGridLines: Boolean;
    AutoConvertFirstLetterInFileNames: Boolean;
    AutoConvertUnderscoresInFileNames: Boolean;
    AutoURLDecodeFileNames: Boolean;
    DontDisplayTFDDB: Boolean;
    FilenameTemplate: String;
    AutoDelInvalidRecentLinks: Boolean;
    ThumbnailsForAudioFilesAsAPIC: Boolean;
    ThumbnailerTextZoom: Cardinal;
    NoCDN_TYPECHANGE: Boolean;
    ListerHasTheFocus: Boolean;
    NoBalloonWhenFileNameHasFocus: Boolean;
    
    Constructor Create(AOwner: TComponent); override;
    Destructor Destroy; override;
    procedure LoadSettings;
    procedure SaveSettings;
  end;

//* Exported functions
type
  t_OpenDialog              = function(Params: TOpenDialogParams; var Results: TOpenDialogResults): BOOL; stdcall;
  t_SaveDialog              = function(Params: TOpenDialogParams; var Results: TOpenDialogResults): BOOL; stdcall;
  t_FolderDialog            = function(Params: TOpenDialogParams; var Results: TOpenDialogResults): BOOL; stdcall;

  t_FilesystemDialogsSettings = function: BOOL; stdcall;

  t_InitTOpenDialogParams   = function(var Struct: TOpenDialogParams; MaxFiles: Int64 = 1000): Boolean; stdcall;
  t_FreeTOpenDialogParams   = function(var Struct: TOpenDialogParams): Boolean; stdcall;
  t_InitTOpenDialogResults  = function(var Res: TOpenDialogResults; MaxFiles: Int64 = 1000): Boolean; stdcall;
  t_FreeTOpenDialogResults  = function(var Struct: TOpenDialogResults): Boolean; stdcall;

  t_GetFileName             = function(var OpenFileParams: tagOFN): BOOL; stdcall;

  t_GetPrevProcs            = function(var pGetOpenFileNameA, pGetOpenFileNameW, pGetSaveFileNameA, pGetSaveFileNameW: t_GetFileName): Boolean; register;

type
    TResultsEvent = procedure(Sender: TObject; var FileName: String; var Files: TStrings) of object;

//* Delphi component layer (compatible with TOpenDialog and TSaveDialog, that means you can change the type name from
//* TOpen/SaveDialog to TFilesystemDialog and it should work)
type
  TFilesystemDialog = class(TComponent)
  private
    fDefaultExt: String;
    fFileName: String;
    fFilter: String;
    fInitialDir: String;
    fPath: String;
    fTitle: String;
    fOptions: TOpenOptions;
    fOptionsEx: TOpenOptionsEx;
    fOnSelectionChange: TNotifyEvent;
    fOnFolderChange: TNotifyEvent;
    fOnTypeChange: TNotifyEvent;
    fOnCanClose: TCloseQueryEvent;
    fOnIncludeItem: TIncludeItemEvent;
    fDialogType: TFSDialogType;
    fFiles: TStrings;
    fMaxFiles: Cardinal;
    fGUID: TGUID;
    fInitTOpenDialogParams: t_InitTOpenDialogParams;
    fFreeTOpenDialogParams: t_FreeTOpenDialogParams;
    fInitTOpenDialogResults: t_InitTOpenDialogResults;
    fFreeTOpenDialogResults: t_FreeTOpenDialogResults;
    fSettings: t_FilesystemDialogsSettings;
    fResultsEvent: TResultsEvent;
    //fHookProc: OFNHookProc;
    function GetFileName: TFileName;
    procedure SetFileName(const FileName: TFileName);
    function GetFilterIndex: Integer;
    procedure SetFilterIndex(Index: Integer);
    function GetOptions: TOpenOptions;
    procedure SetOptions(OpenOptions: TOpenOptions);
    function GetOptionsEx: TOpenOptionsEx;
    procedure SetOptionsEx(OpenOptionsEx: TOpenOptionsEx);
    function GetTIFFLZW: Boolean;
    procedure SetTIFFLZW(Allow: Boolean);
    function GetGuid: String;
    procedure SetGuid(const Value: String);
    function ConvertResults(ODResults: TOpenDialogResults): Boolean;
  protected
    //*
  public
    Params: TOpenDialogParams;
    Results: TOpenDialogResults;
    FDLibHandle: THandle;
    FDOpenDialog: t_OpenDialog;
    FDSaveDialog: t_SaveDialog;
    FDFolderDialog: t_FolderDialog;
    DefWinOpenDialog: TOpenDialog;
    DefWinSaveDialog: TSaveDialog;
    function LoadFilesystemDialogsLibrary: Boolean;
    property Files: TStrings read fFiles;
    Constructor Create(AOwner: TComponent); override;
    Destructor Destroy; override;
    function Execute: Boolean;
    function InitTOpenDialogParams(var Struct: TOpenDialogParams; MaxFiles: Int64 = 1000): Boolean;
    function FreeTOpenDialogParams(var Struct: TOpenDialogParams): Boolean;
    function InitTOpenDialogResults(var Res: TOpenDialogResults; MaxFiles: Int64 = 1000): Boolean;
    function FreeTOpenDialogResults(var Struct: TOpenDialogResults): Boolean;
    function Settings: Boolean;
    function CallDefWinDialog: Boolean;
    //function CallbackResults(Wnd: HWND; Msg: UINT; wParam: WPARAM; lParam: LPARAM): UINT; stdcall;
  published
    property DialogType: TFSDialogType read fDialogType write fDialogType default fsdtOpenDialog;
    property DefaultExt: String read fDefaultExt write fDefaultExt;
    property FileName: TFileName read GetFileName write SetFileName;
    property Filter: String read fFilter write fFilter;
    property FilterIndex: Integer read GetFilterIndex write SetFilterIndex default 1;
    property InitialDir: String read fInitialDir write fInitialDir;
    property Path: String read fPath;
    property Options: TOpenOptions read GetOptions write SetOptions;
    property OptionsEx: TOpenOptionsEx read GetOptionsEx write SetOptionsEx;
    property DialogTitle: String read fTitle write fTitle;
    property AllowTIFFLZW: Boolean read GetTIFFLZW write SetTIFFLZW default False;
    property OnCanClose: TCloseQueryEvent read fOnCanClose write fOnCanClose;
    property OnFolderChange: TNotifyEvent read fOnFolderChange write fOnFolderChange;
    property OnSelectionChange: TNotifyEvent read fOnSelectionChange write fOnSelectionChange;
    property OnTypeChange: TNotifyEvent read fOnTypeChange write fOnTypeChange;
    property OnIncludeItem: TIncludeItemEvent read fOnIncludeItem write fOnIncludeItem;
    property OnResults: TResultsEvent read fResultsEvent write fResultsEvent;
    property MaxFiles: Cardinal read fMaxFiles write fMaxFiles;
    property DialogGUID: String read GetGUID write SetGUID;
  end;

    procedure Register;

//* Store .dll info here for the Delphi component layer
var
  SHGetImageList: t_SHGetImageList;

implementation

Uses Registry
{$IFDEF _FILESYSTEM_DIALOGS_COMPILE}
    , FileDialog
{$ENDIF}
;

procedure Register;
begin
    RegisterComponents('3delite', [TFilesystemDialog]);
end;

function Bytes2MB(Bytes: Int64): String;
begin
    if Bytes > 1048576 then begin
        if Bytes > 1073741824
            then Result := FloatToStrF((Bytes / 1073741824), ffFixed, 4, 2) + ' GB'
            else Result := FloatToStrF((Bytes / 1048576), ffFixed, 4, 2) + ' MB';
    end else Result := FloatToStrF((Bytes / 1024), ffFixed, 4, 2) + ' KB';
    if Bytes < 1024
 	    then Result := IntToStr(Bytes) + ' Bytes';
end;

{$IFDEF _FILESYSTEM_DIALOGS_COMPILE}
function TFileData.SolvedFileName: String;
var
  Desc: String;
begin
    if (fSolvedFileName = '')
    OR (NOT FileExistsEx(fSolvedFileName))
    then begin
        fSolvedFileName := SolveLink(Self.FileName, Self.fWinHandle, Desc, fDelBadLink);
        if Self.FileName <> fSolvedFileName
            then Self.Description := Desc;
    end else Result := fSolvedFileName;
end;
{$ENDIF}

Destructor TFileData.Destroy;
begin
    DestroyIcon(Self.IconHandle);
    Inherited Destroy;
end;

 (*
function CallbackResults(Wnd: HWND; Msg: UINT; wParam: WPARAM; lParam: LPARAM): UINT stdcall;
type
  POpenDialogResults = ^TOpenDialogResults;
var
  Res: POpenDialogResults;
  Text: String;
  Parent: TFilesystemDialog;
begin

    if Msg = FDM_RESULTS then begin

        Res := POpenDialogResults(wParam);

        Text := PChar(Res.FileName);
        //* Itt:
        Showmessage(Text);
        //FormFDD.Memo1.Lines.Add(Text);

        Parent :=  TFilesystemDialog(Pointer(lParam));

        //* Free memory
        {
        FreeMem(Res.FileName);
        FreeMem(Res.FileNames);
        }
        Parent.FreeTOpenDialogResults(Res^);

        if Assigned(Parent.fResultsEvent)
            then Parent.fResultsEvent(Parent, Parent.fFileName, Parent.fFiles);

    end;
end;
 *)

constructor TFilesystemDialog.Create(AOwner: TComponent);
begin
    inherited Create(AOwner);
    FDLibHandle := 0;
    DefWinOpenDialog := nil;
    DefWinSaveDialog := nil;
    try
        Params.ParentWindow := Application.Handle;
        Params.ParentWindow := 0;
    except
        Params.ParentWindow := 0;
    end;
    if ComponentState = [csDesigning, csFreeNotification]
        then CreateGUID(fGUID);
    fMaxFiles := 100;
    fFiles := TStringList.Create;
    LoadFilesystemDialogsLibrary;
    //fHookProc := OFNHookProc(@CallbackResults);
end;

destructor TFilesystemDialog.Destroy;
begin
    try
        FreeAndNil(fFiles);
        FreeLibrary(FDLibHandle);
        //FDLibHandle := 0;
        FreeAndNil(DefWinOpenDialog);
        FreeAndNil(DefWinSaveDialog);
    except
        //*
    end;
    try
        inherited Destroy;
    except
        //*
    end;
end;

function TFilesystemDialog.LoadFilesystemDialogsLibrary: Boolean;
begin
    Result := False;
    FDLibHandle := SafeLoadLibrary(PChar(FILENAME_DLL_FD));
    if FDLibHandle <> 0 then begin
        FDOpenDialog := GetProcAddress(FDLibHandle, PChar(NAME_FD_OpenDialog));
        FDSaveDialog := GetProcAddress(FDLibHandle, PChar(NAME_FD_SaveDialog));
        FDFolderDialog := GetProcAddress(FDLibHandle, PChar(NAME_FD_FolderDialog));
        fSettings := GetProcAddress(FDLibHandle, PChar(NAME_FD_Settings));
        fInitTOpenDialogParams := GetProcAddress(FDLibHandle, PChar(NAME_FD_InitTOpenDialogParams));
        fFreeTOpenDialogParams := GetProcAddress(FDLibHandle, PChar(NAME_FD_FreeTOpenDialogParams));
        fInitTOpenDialogResults := GetProcAddress(FDLibHandle, PChar(NAME_FD_InitTOpenDialogResults));
        fFreeTOpenDialogResults := GetProcAddress(FDLibHandle, PChar(NAME_FD_FreeTOpenDialogResults));
        if (@FDOpenDialog = nil)
        OR (@FDSaveDialog = nil)
        OR (@FDFolderDialog = nil)
        OR (@fSettings = nil)
        OR (@fInitTOpenDialogParams = nil)
        OR (@fInitTOpenDialogResults = nil)
        OR (@fInitTOpenDialogResults = nil)
        OR (@fFreeTOpenDialogResults = nil)
            then Result := False
            else Result := True;
        if NOT Result then begin
            FreeLibrary(FDLibHandle);
            FDLibHandle := 0;
        end;
    end;
    if NOT Result then begin
        if DefWinOpenDialog = nil
            then DefWinOpenDialog := TOpenDialog.Create(Self);
        if DefWinSaveDialog = nil
            then DefWinSaveDialog := TSaveDialog.Create(Self);
    end;
end;

function TFilesystemDialog.Execute: Boolean;
  {
var
  pName: PChar;
  }
begin

    Result := False;

    //fFileName := '';
    fFiles.Text := '';
    Results.FilterIndex := -1;

    //* Acquire library
    if FDLibHandle = 0
    	then if NOT LoadFilesystemDialogsLibrary
            then begin
                Result := CallDefWinDialog;
                Exit;
            end;

    //* GetMem
    if NOT InitTOpenDialogResults(Results, fMaxFiles)
        then Exit;

    //* Fill here
    Params.Options := fOptions;
    Params.OptionsEx := fOptionsEx;
    Params.DefaultExt := Pchar(fDefaultExt);
    Params.FileName := Pchar(fFileName);
    Params.Filters := Pchar(fFilter);
    Params.InitialDir := Pchar(fInitialDir);
    Params.Title := Pchar(fTitle);
    Params.DialogType := fDialogType;
    Params.DialogGUID := fGUID;

    //if (ofNotModal in Params.Options)
    //    then Params.HookProc := fHookProc;

    //* Execute
    case Params.DialogType of
        fsdtOpenDialog: Result := FDOpenDialog(Params, Results);
        fsdtSaveDialog: Result := FDSaveDialog(Params, Results);
        fsdtFolderDialog: Result := FDFolderDialog(Params, Results);
    end;

    if NOT (ofNotModal in Params.Options)
        then Result := ConvertResults(Results);

    //* Release mem
    if NOT (ofNotModal in Params.Options)
        then FreeTOpenDialogResults(Results);

end;

function TFilesystemDialog.ConvertResults(ODResults: TOpenDialogResults): Boolean;
var
  pName: PChar;
begin
    Result := ODResults.Successfull;
    //* Fill results
    if Result then begin
        fFileName := ODResults.FileName;
        Params.FileName := PChar(fFileName);
        fPath := ExtractFilePath(fFileName);
        //* Convert filename list
        if fFiles = nil
            then fFiles := TStringList.Create;
        fFiles.Clear;
        pName := ODResults.FileNames;
        while pName^ <> #0 do begin
            fFiles.Text := fFiles.Text + pName + (#13#10);
            // Point to the next filename
            Inc(pName, Length(pName) + 1);
        end;
        fFiles.Text := Copy(fFiles.Text, 1, Length(fFiles.Text) - 2);
        Results.FilterIndex := ODResults.FilterIndex;
        Results.FileCount := fFiles.Count;
    end;
end;

function TFilesystemDialog.CallDefWinDialog: Boolean;
begin
    Result := False;
    try
        //* Execute
        case fDialogType of
            fsdtOpenDialog: begin
                if DefWinOpenDialog <> nil then begin
                    DefWinOpenDialog.Options := Dialogs.TOpenOptions(fOptions);
                    //DefWinOpenDialog.Options := DefWinOpenDialog.Options + Dialogs.TOpenOption.ofEnableSizing;
                    DefWinOpenDialog.OptionsEx := Dialogs.TOpenOptionsEx(fOptionsEx);
                    DefWinOpenDialog.DefaultExt := Pchar(fDefaultExt);
                    DefWinOpenDialog.FileName := fFileName;
                    DefWinOpenDialog.Filter := fFilter;
                    DefWinOpenDialog.FilterIndex := Self.FilterIndex + 1;
                    DefWinOpenDialog.InitialDir := fInitialDir;
                    DefWinOpenDialog.Title := fTitle;
                    Result := DefWinOpenDialog.Execute;
                    if Result then begin
                        fFileName := DefWinOpenDialog.FileName;
                        Params.FileName := PChar(fFileName);
                        fPath := ExtractFilePath(fFileName);
                        fFiles.Text := DefWinOpenDialog.Files.Text;
                        Self.FilterIndex := DefWinOpenDialog.FilterIndex - 1;
                        Results.FileCount := DefWinOpenDialog.Files.Count;
                    end;
                end;
            end;
            fsdtSaveDialog: begin
                if DefWinSaveDialog <> nil then begin
                    DefWinSaveDialog.Options := Dialogs.TOpenOptions(fOptions);
                    //DefWinSaveDialog.Options := DefWinSaveDialog.Options + Dialogs.TOpenOption.ofEnableSizing;
                    DefWinSaveDialog.OptionsEx := Dialogs.TOpenOptionsEx(fOptionsEx);
                    DefWinSaveDialog.DefaultExt := Pchar(fDefaultExt);
                    DefWinSaveDialog.FileName := fFileName;
                    DefWinSaveDialog.Filter := fFilter;
                    DefWinSaveDialog.FilterIndex := Self.FilterIndex + 1;
                    DefWinSaveDialog.InitialDir := fInitialDir;
                    DefWinSaveDialog.Title := fTitle;
                    Result := DefWinSaveDialog.Execute;
                    if Result then begin
                        fFileName := DefWinSaveDialog.FileName;
                        Params.FileName := PChar(fFileName);
                        fPath := ExtractFilePath(fFileName);
                        fFiles.Text := DefWinSaveDialog.Files.Text;
                        Self.FilterIndex := DefWinSaveDialog.FilterIndex - 1;
                        Results.FileCount := DefWinSaveDialog.Files.Count;
                    end;
                end;
            end;
            fsdtFolderDialog: begin
                //* Not yet
            end;
        end;
    except
        //*
    end;
end;

function TFilesystemDialog.InitTOpenDialogParams(var Struct: TOpenDialogParams; MaxFiles: Int64 = 1000): Boolean;
begin
    if NOT Assigned(fInitTOpenDialogParams)
        then Result := False
        else Result := fInitTOpenDialogParams(Struct, MaxFiles);
end;

function TFilesystemDialog.FreeTOpenDialogParams(var Struct: TOpenDialogParams): Boolean;
begin
    if NOT Assigned(fFreeTOpenDialogParams)
        then Result := False
        else Result := fFreeTOpenDialogParams(Struct);
end;

function TFilesystemDialog.InitTOpenDialogResults(var Res: TOpenDialogResults; MaxFiles: Int64 = 1000): Boolean;
begin
    if NOT Assigned(fInitTOpenDialogResults)
        then Result := False
        else Result := fInitTOpenDialogResults(Res, MaxFiles);
end;

function TFilesystemDialog.FreeTOpenDialogResults(var Struct: TOpenDialogResults): Boolean;
begin
    if NOT Assigned(fFreeTOpenDialogResults)
        then Result := False
        else Result := fFreeTOpenDialogResults(Struct);
end;

function TFilesystemDialog.Settings: Boolean;
begin
    if NOT Assigned(fSettings)
        then Result := False
        else Result := fSettings;
end;

function TFilesystemDialog.GetFileName: TFileName;
begin
    Result := fFileName;
end;

procedure TFilesystemDialog.SetFileName(const FileName: TFileName);
begin
    fFileName := FileName;
end;

function TFilesystemDialog.GetFilterIndex: Integer;
begin
    Result := Results.FilterIndex;
end;

procedure TFilesystemDialog.SetFilterIndex(Index: Integer);
begin
    Results.FilterIndex := Index;
    Params.FilterIndex := Index;
end;

function TFilesystemDialog.GetOptions: TOpenOptions;
begin
    Result := fOptions;
end;

procedure TFilesystemDialog.SetOptions(OpenOptions: TOpenOptions);
begin
    fOptions := OpenOptions
end;

function TFilesystemDialog.GetOptionsEx: TOpenOptionsEx;
begin
    Result := fOptionsEx;
end;

procedure TFilesystemDialog.SetOptionsEx(OpenOptionsEx: TOpenOptionsEx);
begin
    fOptionsEx := OpenOptionsEx;
end;

function TFilesystemDialog.GetTIFFLZW: Boolean;
begin
    Result := Params.AllowTIFFLZW;
end;

procedure TFilesystemDialog.SetTIFFLZW(Allow: Boolean);
begin
    Params.AllowTIFFLZW := Allow;
end;

function TFilesystemDialog.GetGUID: String;
begin
    Result := GUIDToString(fGUID);
end;

procedure TFilesystemDialog.SetGUID(const Value: String);
begin
    fGUID := StringToGUID(Value);
end;

 (*
function TFilesystemDialog.CallbackResults(Wnd: HWND; Msg: UINT; wParam: WPARAM; lParam: LPARAM): UINT stdcall;
type
  POpenDialogResults = ^TOpenDialogResults;
var
  Res: POpenDialogResults;
  Text: String;
begin
    if Msg = FDM_RESULTS then begin

        Res := POpenDialogResults(wParam);

        Text := PChar(Res.FileName);
        //* Itt:
        Showmessage(Text);
        //FormFDD.Memo1.Lines.Add(Text);

        //* Free memory
        {
        FreeMem(Res.FileName);
        FreeMem(Res.FileNames);
        }
        FreeTOpenDialogResults(Res^);

        if Assigned(fResultsEvent)
            then fResultsEvent(Self, fFileName, fFiles);

    end;
end;
 *)

//* TFileSystemDialogsSettings

constructor TFileSystemDialogsSettings.Create(AOwner: TComponent);
begin
    inherited Create(AOwner);
    Font := TFont.Create;
    Daynames := True;
end;

destructor TFileSystemDialogsSettings.Destroy;
begin
    Font.Free;
    inherited Destroy;
end;

//* Load the global settings from the registry
//* This is the place also where the default settings are specified
procedure TFileSystemDialogsSettings.LoadSettings;
var
  Reg: TRegistry;
begin
    Reg := TRegistry.Create;
    try
        Reg.RootKey := HKEY_CURRENT_USER;

        //* Global
        Reg.OpenKey(STR_REG_FD_SETTINGS + '\', False);

        if Reg.ValueExists(STR_REG_USE_LAST_FOLDER)
            then UseLastFolder := Reg.ReadBool(STR_REG_USE_LAST_FOLDER)
            else UseLastFolder := True;

        if Reg.ValueExists(STR_REG_SINGLE_SETUP)
            then SingleSetup := Reg.ReadBool(STR_REG_SINGLE_SETUP)
            else SingleSetup := False;

        if Reg.ValueExists(STR_REG_PRECISION)
            then Precision := Reg.ReadBool(STR_REG_PRECISION)
            else Precision := False;

        if Reg.ValueExists(STR_REG_READ_CREATED_FOLDER)
            then AutoGoIntoCreatedFolder := Reg.ReadBool(STR_REG_READ_CREATED_FOLDER)
            else AutoGoIntoCreatedFolder := True;

        if Reg.ValueExists(STR_REG_SAVE_SETTINGS_ON_CANCEL)
            then SaveSettingsOnCancel := Reg.ReadBool(STR_REG_SAVE_SETTINGS_ON_CANCEL)
            else SaveSettingsOnCancel := False;

        if Reg.ValueExists(STR_REG_LANCZOS_FOR_THUMBNAILS)
            then LanczosFilterForThumbnails := Reg.ReadBool(STR_REG_LANCZOS_FOR_THUMBNAILS)
            else LanczosFilterForThumbnails := True;

        if Reg.ValueExists(STR_REG_THUMBNAILS_FOR_DIRS)
            then ThumbnailsForDirs := Reg.ReadBool(STR_REG_THUMBNAILS_FOR_DIRS)
            else ThumbnailsForDirs := False;

        if Reg.ValueExists(STR_REG_THUMBNAILS_FOR_DIR_AUDIO)
            then ThumbnailsForDirsAudio := Reg.ReadBool(STR_REG_THUMBNAILS_FOR_DIR_AUDIO)
            else ThumbnailsForDirsAudio := False;

        if Reg.ValueExists(STR_REG_THUMBNAILS_FOR_AUDIOFILES)
            then ThumbnailsForAudioFiles := Reg.ReadBool(STR_REG_THUMBNAILS_FOR_AUDIOFILES)
            else ThumbnailsForAudioFiles := True;

        if Reg.ValueExists(STR_REG_THUMBNAILS_FOR_TEXTFILES)
            then ThumbnailsForTextFiles := Reg.ReadBool(STR_REG_THUMBNAILS_FOR_TEXTFILES)
            else ThumbnailsForTextFiles := True;

        if Reg.ValueExists(STR_REG_THUMBNAILS_BCKG_COLOR)
            then ThumbnailsUseCustomBckgColor := Reg.ReadBool(STR_REG_THUMBNAILS_BCKG_COLOR)
            else ThumbnailsUseCustomBckgColor := False;

        if Reg.ValueExists(STR_REG_THUMBNAILS_BCKG_COLOR_V)
            then ThumbnailsCustomBckgColor := Reg.ReadInteger(STR_REG_THUMBNAILS_BCKG_COLOR_V)
            else ThumbnailsCustomBckgColor := $FFFFFFFF;

        if Reg.ValueExists(STR_REG_THUMBNAILS_BCKG_PIC_COLOR)
            then ThumbnailsPictureUseCustomBckgColor := Reg.ReadBool(STR_REG_THUMBNAILS_BCKG_PIC_COLOR)
            else ThumbnailsPictureUseCustomBckgColor := True;

        if Reg.ValueExists(STR_REG_THUMBNAILS_BCKG_PIC_COLOR_V)
            then ThumbnailsPictureCustomBckgColor := Reg.ReadInteger(STR_REG_THUMBNAILS_BCKG_PIC_COLOR_V)
            else ThumbnailsPictureCustomBckgColor := $FF000000;

        if Reg.ValueExists(STR_REG_THUMBNAILS_FONT_COLOR)
            then ThumbnailsUseCustomFontColor := Reg.ReadBool(STR_REG_THUMBNAILS_FONT_COLOR)
            else ThumbnailsUseCustomFontColor := False;

        if Reg.ValueExists(STR_REG_THUMBNAILS_FONT_COLOR_FOLDER_V)
            then ThumbnailsUseFolderFontColor := Reg.ReadInteger(STR_REG_THUMBNAILS_FONT_COLOR_FOLDER_V)
            else ThumbnailsUseFolderFontColor := THUMBNAIL_COLOR_FOLDER_NAME;

        if Reg.ValueExists(STR_REG_THUMBNAILS_FONT_COLOR_FILE_V)
            then ThumbnailsUseFileNameColor := Reg.ReadInteger(STR_REG_THUMBNAILS_FONT_COLOR_FILE_V)
            else ThumbnailsUseFileNameColor := THUMBNAIL_COLOR_FILE_NAME;

        if Reg.ValueExists(STR_REG_THUMBNAILS_FONT_COLOR_EXT_V)
            then ThumbnailsUseExtColor := Reg.ReadInteger(STR_REG_THUMBNAILS_FONT_COLOR_EXT_V)
            else ThumbnailsUseExtColor := THUMBNAIL_COLOR_EXTENSION;

        if Reg.ValueExists(STR_REG_THUMBNAILS_ZOOM_X2)
            then ThumbnailsSmallZoomx2 := Reg.ReadBool(STR_REG_THUMBNAILS_ZOOM_X2)
            else ThumbnailsSmallZoomx2 := False;

        if Reg.ValueExists(STR_REG_THUMBNAILS_FOLDER_CAP_CENTER)
            then ThumbnailsCenterFolderCaps := Reg.ReadBool(STR_REG_THUMBNAILS_FOLDER_CAP_CENTER)
            else ThumbnailsCenterFolderCaps := True;

        if Reg.ValueExists(STR_REG_THUMBNAILS_AVOID_EXIF)
            then ThumbnailsAvoidEXIF := Reg.ReadBool(STR_REG_THUMBNAILS_AVOID_EXIF)
            else ThumbnailsAvoidEXIF := False;

        if Reg.ValueExists(STR_REG_THREAD_THUMBNAILER)
            then ThumbnailerThreading := Reg.ReadBool(STR_REG_THREAD_THUMBNAILER)
            else ThumbnailerThreading := False;

        if Reg.ValueExists(STR_REG_THUMBNAILS_WIDTH)
            then ThumbnailsWidth := Reg.ReadInteger(STR_REG_THUMBNAILS_WIDTH)
            else ThumbnailsWidth := 120;

        if Reg.ValueExists(STR_REG_THUMBNAILS_HEIGHT)
            then ThumbnailsHeight := Reg.ReadInteger(STR_REG_THUMBNAILS_HEIGHT)
            else ThumbnailsHeight := 100;

        if Reg.ValueExists(STR_REG_THUMBNAILS_SIZE_PRESET)
            then ThumbnailsSizePreset := Reg.ReadInteger(STR_REG_THUMBNAILS_SIZE_PRESET)
            else ThumbnailsSizePreset := 1;

        if Reg.ValueExists(STR_REG_THUMBNAILS_SAMPLE_COLOR_L)
            then ThumbnailsSampleColorL := Reg.ReadInteger(STR_REG_THUMBNAILS_SAMPLE_COLOR_L)
            else ThumbnailsSampleColorL := THUMBNAIL_COLOR_L;

        if Reg.ValueExists(STR_REG_THUMBNAILS_SAMPLE_COLOR_R)
            then ThumbnailsSampleColorR := Reg.ReadInteger(STR_REG_THUMBNAILS_SAMPLE_COLOR_R)
            else ThumbnailsSampleColorR := THUMBNAIL_COLOR_R;

        if Reg.ValueExists(STR_REG_THUMBNAILS_SAMPLE_COLOR_B)
            then ThumbnailsSampleColorB := Reg.ReadInteger(STR_REG_THUMBNAILS_SAMPLE_COLOR_B)
            else ThumbnailsSampleColorB := THUMBNAIL_COLOR_B;

        if Reg.ValueExists(STR_REG_THUMBNAILS_SAMPLE_AA)
            then ThumbnailsSampleAALEvel := Reg.ReadInteger(STR_REG_THUMBNAILS_SAMPLE_AA)
            else ThumbnailsSampleAALEvel := 4;

        if Reg.ValueExists(STR_REG_SAVE_SESC)
            then SaveSESC := Reg.ReadBool(STR_REG_SAVE_SESC)
            else SaveSESC := True;

        if Reg.ValueExists(STR_REG_ALLOW_GIFANDTIFFLZW)
            then AllowTIFFLZW := Reg.ReadBool(STR_REG_ALLOW_GIFANDTIFFLZW)
            else AllowTIFFLZW := False;

        if Reg.ValueExists(STR_REG_FS_FORCE_EXTCASE)
            then ForceExtCase := Reg.ReadBool(STR_REG_FS_FORCE_EXTCASE)
            else ForceExtCase := False;

        if Reg.ValueExists(STR_REG_FS_FORCE_EXTCASEU)
            then ForceExtCaseUpper := Reg.ReadBool(STR_REG_FS_FORCE_EXTCASEU)
            else ForceExtCaseUpper := False;

        if Reg.ValueExists(STR_REG_FS_FORCE_EXTCASEL)
            then ForceExtCaseLower := Reg.ReadBool(STR_REG_FS_FORCE_EXTCASEL)
            else ForceExtCaseLower := False;

        if Reg.ValueExists(STR_REG_INACTIVE_TREEVIEW)
            then InactiveTreeViewUntilFirstTouch := Reg.ReadBool(STR_REG_INACTIVE_TREEVIEW)
            else InactiveTreeViewUntilFirstTouch := True;

        if Reg.ValueExists(STR_REG_OMIT_FILE_EXT)
            then OmitFileExt := Reg.ReadBool(STR_REG_OMIT_FILE_EXT)
            else OmitFileExt := False;

        if Reg.ValueExists(STR_REG_ID3_DESCRIPTION)
            then DisplayID3InDescription := Reg.ReadBool(STR_REG_ID3_DESCRIPTION)
            else DisplayID3InDescription := False;

        if Reg.ValueExists(STR_REG_SETTINGS_TOP)
            then SettingsWindowPosition.Y := Reg.ReadInteger(STR_REG_SETTINGS_TOP)
            else SettingsWindowPosition.Y := -1;

        if Reg.ValueExists(STR_REG_SETTINGS_LEFT)
            then SettingsWindowPosition.X := Reg.ReadInteger(STR_REG_SETTINGS_LEFT)
            else SettingsWindowPosition.X := -1;

        if Reg.ValueExists(STR_REG_SETTINGS_PAGE_INDEX)
            then SettingsPageIndex := Reg.ReadInteger(STR_REG_SETTINGS_PAGE_INDEX)
            else SettingsPageIndex := 0;

        if Reg.ValueExists(STR_REG_SETTINGS_PAGE_THUMBS_INDEX)
            then SettingsPageThumbsIndex := Reg.ReadInteger(STR_REG_SETTINGS_PAGE_THUMBS_INDEX)
            else SettingsPageThumbsIndex := 0;

        if Reg.ValueExists(STR_REG_SETTINGS_PAGE_PREFS_INDEX)
            then SettingsPagePrefsIndex := Reg.ReadInteger(STR_REG_SETTINGS_PAGE_PREFS_INDEX)
            else SettingsPagePrefsIndex := 0;

        if Reg.ValueExists(STR_REG_RECENT_FOLDER_COUNT)
            then RecentFolderCount := Reg.ReadInteger(STR_REG_RECENT_FOLDER_COUNT)
            else RecentFolderCount := 32;

        if Reg.ValueExists(STR_REG_SHOW_SCROLLBAR_RECENT)
            then ShowScrollbarsRecent := Reg.ReadBool(STR_REG_SHOW_SCROLLBAR_RECENT)
            else ShowScrollbarsRecent := False;

        if Reg.ValueExists(STR_REG_SHOW_SCROLLBAR_TREEVIEW)
            then ShowScrollbarsTreeView := Reg.ReadBool(STR_REG_SHOW_SCROLLBAR_TREEVIEW)
            else ShowScrollbarsTreeView := True;

        if Reg.ValueExists(STR_REG_THUMBNAILS_CACHED)
            then ThumbnailsCache := Reg.ReadBool(STR_REG_THUMBNAILS_CACHED)
            else if Reg.ValueExists(STR_REG_THUMBNAILS_CACHED_GRAPHICAL)
                then ThumbnailsCache := Reg.ReadBool(STR_REG_THUMBNAILS_CACHED_GRAPHICAL)
                else ThumbnailsCache := True;

        if Reg.ValueExists(STR_REG_SETTINGS_DISPLAY_EXTS_CONVERTED)
            then ConvertDisplayExtensions := Reg.ReadBool(STR_REG_SETTINGS_DISPLAY_EXTS_CONVERTED)
            else ConvertDisplayExtensions := False;

        if Reg.ValueExists(STR_REG_SEC_VIEWER)
            then UseSecondaryViewer := Reg.ReadBool(STR_REG_SEC_VIEWER)
            else UseSecondaryViewer := False;

        if Reg.ValueExists(STR_REG_SEC_VIEWER_SPECIFY)
            then SecondaryViewerSpecified := Reg.ReadBool(STR_REG_SEC_VIEWER_SPECIFY)
            else SecondaryViewerSpecified := False;

        if Reg.ValueExists(STR_REG_SEC_VIEWER_MONITOR)
            then SecondaryViewerMonitorNo := Reg.ReadInteger(STR_REG_SEC_VIEWER_MONITOR)
            else SecondaryViewerMonitorNo := 0;

        if Reg.ValueExists(STR_REG_SEC_VIEWER_AUDIO)
            then SecondaryViewerAudio := Reg.ReadBool(STR_REG_SEC_VIEWER_AUDIO)
            else SecondaryViewerAudio := True;

        if Reg.ValueExists(STR_REG_SEC_VIEWER_AUDIO_NO_STATUS)
            then SecondaryViewerAudioNoProgress := Reg.ReadBool(STR_REG_SEC_VIEWER_AUDIO_NO_STATUS)
            else SecondaryViewerAudioNoProgress := False;

        if Reg.ValueExists(STR_REG_SEC_VIEWER_AUDIO_NO_INFO)
            then SecondaryViewerAudioNoInfo := Reg.ReadBool(STR_REG_SEC_VIEWER_AUDIO_NO_INFO)
            else SecondaryViewerAudioNoInfo := False;

        if Reg.ValueExists(STR_REG_SEC_VIEWER_AUDIO_AA)
            then SecondaryViewerAudioAA := Reg.ReadInteger(STR_REG_SEC_VIEWER_AUDIO_AA)
            else SecondaryViewerAudioAA := 4;

        if Reg.ValueExists(STR_REG_SEC_VIEWER_PICTURE)
            then SecondaryViewerPicture := Reg.ReadBool(STR_REG_SEC_VIEWER_PICTURE)
            else SecondaryViewerPicture := True;

        if Reg.ValueExists(STR_REG_SEC_VIEWER_PICTURE_RESAMPLER)
            then SecondaryViewerPictureResampler := Reg.ReadInteger(STR_REG_SEC_VIEWER_PICTURE_RESAMPLER)
            else SecondaryViewerPictureResampler := 6;  //* 6 = Lanczos

        if Reg.ValueExists(STR_REG_SEC_VIEWER_HTML)
            then SecondaryViewerHTML := Reg.ReadBool(STR_REG_SEC_VIEWER_HTML)
            else SecondaryViewerHTML := True;

        if Reg.ValueExists(STR_REG_SEC_VIEWER_TEXT_RTF)
            then SecondaryViewerTEXTRTF := Reg.ReadBool(STR_REG_SEC_VIEWER_TEXT_RTF)
            else SecondaryViewerTEXTRTF := True;

        if Reg.ValueExists(STR_REG_BALLOON_IN_LISTER)
            then BalloonInLister := Reg.ReadBool(STR_REG_BALLOON_IN_LISTER)
            else BalloonInLister := True;

        if Reg.ValueExists(STR_REG_BALLOON_IN_THUMBNAIL)
            then BalloonInThumbnailMode := Reg.ReadBool(STR_REG_BALLOON_IN_THUMBNAIL)
            else BalloonInThumbnailMode := True;

        if Reg.ValueExists(STR_REG_BALLOON_THUMBNAILS)
            then BalloonHasThumbs := Reg.ReadBool(STR_REG_BALLOON_THUMBNAILS)
            else BalloonHasThumbs := True;

        if Reg.ValueExists(STR_REG_BALLOON_HINT_TIMEOUT)
            then BalloonHintTimeOut := Reg.ReadInteger(STR_REG_BALLOON_HINT_TIMEOUT)
            else BalloonHintTimeOut := 0;

        if Reg.ValueExists(STR_REG_TYPES_BROWSER)
            then TypesBrowser := Reg.ReadString(STR_REG_TYPES_BROWSER)
            else TypesBrowser := FILE_TYPES_BROWSER;

        if Reg.ValueExists(STR_REG_TYPES_AUDIO)
            then TypesAudio := Reg.ReadString(STR_REG_TYPES_AUDIO)
            else TypesAudio := FILE_TYPES_AUDIO;

        if Reg.ValueExists(STR_REG_TYPES_TEXT)
            then TypesText := Reg.ReadString(STR_REG_TYPES_TEXT)
            else TypesText := FILE_TYPES_TEXT;

        if Reg.ValueExists(STR_REG_BALLOON_IN_DRIVES)
            then BalloonInDrives := Reg.ReadBool(STR_REG_BALLOON_IN_DRIVES)
            else BalloonInDrives := True;

        if Reg.ValueExists(STR_REG_GRID_LINES)
            then EnableGridLines := Reg.ReadBool(STR_REG_GRID_LINES)
            else EnableGridLines := True;

        if Reg.ValueExists(STR_REG_URL_DECODE_FILENAMES)
            then AutoURLDecodeFileNames := Reg.ReadBool(STR_REG_URL_DECODE_FILENAMES)
            else AutoURLDecodeFileNames := True;

        if Reg.ValueExists(STR_REG_UPPERCASE_FIRST_LETTER_FOR_FILENAMES)
            then AutoConvertFirstLetterInFileNames := Reg.ReadBool(STR_REG_UPPERCASE_FIRST_LETTER_FOR_FILENAMES)
            else AutoConvertFirstLetterInFileNames := True;

        if Reg.ValueExists(STR_REG_UNDERSCORES_2_SPACE_FOR_FILENAMES)
            then AutoConvertUnderscoresInFileNames := Reg.ReadBool(STR_REG_UNDERSCORES_2_SPACE_FOR_FILENAMES)
            else AutoConvertUnderscoresInFileNames := True;

        if Reg.ValueExists(STR_REG_RECENT_FILES_COUNT)
            then RecentFileCount := Reg.ReadInteger(STR_REG_RECENT_FILES_COUNT)
            else RecentFileCount := 100;

        if Reg.ValueExists(STR_REG_DONTDISAPLAY_TFDDB)
            then DontDisplayTFDDB := Reg.ReadBool(STR_REG_DONTDISAPLAY_TFDDB)
            else DontDisplayTFDDB := True;

        if Reg.ValueExists(STR_REG_FILENAME_TEMPLATE)
            then FilenameTemplate := Reg.ReadString(STR_REG_FILENAME_TEMPLATE)
            else FilenameTemplate := '{n}{e}';

        if Reg.ValueExists(STR_REG_RECENT_FILES_DEL_INVALID)
            then AutoDelInvalidRecentLinks := Reg.ReadBool(STR_REG_RECENT_FILES_DEL_INVALID)
            else AutoDelInvalidRecentLinks := False;

        if Reg.ValueExists(STR_REG_THUMBNAILS_FOR_AUDIOFILES_APIC)
            then ThumbnailsForAudioFilesAsAPIC := Reg.ReadBool(STR_REG_THUMBNAILS_FOR_AUDIOFILES_APIC)
            else ThumbnailsForAudioFilesAsAPIC := True;

        if Reg.ValueExists(STR_REG_THUMBNAILER_TEXT_ZOOM)
            then ThumbnailerTextZoom := Reg.ReadInteger(STR_REG_THUMBNAILER_TEXT_ZOOM)
            else ThumbnailerTextZoom := 150;

        if Reg.ValueExists(STR_REG_SEC_VIEWER_HTML_UNKNOWN_TYPES)
            then SecondaryViewerHTMLAllFiles := Reg.ReadBool(STR_REG_SEC_VIEWER_HTML_UNKNOWN_TYPES)
            else SecondaryViewerHTMLAllFiles := False;

        if Reg.ValueExists(STR_REG_NO_CDN_TYPECHANGE)
            then NoCDN_TYPECHANGE := Reg.ReadBool(STR_REG_NO_CDN_TYPECHANGE)
            else NoCDN_TYPECHANGE := False;

        if Reg.ValueExists(STR_REG_LISTER_HAS_THE_FOCUS)
            then ListerHasTheFocus := Reg.ReadBool(STR_REG_LISTER_HAS_THE_FOCUS)
            else ListerHasTheFocus := False;

        if Reg.ValueExists(STR_REG_BALLOON_NO_FILENAME_FOCUS)
            then NoBalloonWhenFileNameHasFocus := Reg.ReadBool(STR_REG_BALLOON_NO_FILENAME_FOCUS)
            else NoBalloonWhenFileNameHasFocus := True;

        Reg.CloseKey;

        Reg.OpenKey(STR_REG_FD_SETTINGS + '\', True);

        //* Read only values
        if Reg.ValueExists(STR_REG_BASS_DONTINIT)
            then BASSDontInit := Reg.ReadBool(STR_REG_BASS_DONTINIT)
            else Reg.WriteBool(STR_REG_BASS_DONTINIT, False);

        Reg.CloseKey;

        //* Font
        if Reg.KeyExists(STR_REG_FD_SETTINGS + '\' + STR_REG_FD_FONT_SETTINGS + '\') then begin
            Reg.OpenKey(STR_REG_FD_SETTINGS + '\' + STR_REG_FD_FONT_SETTINGS + '\', False);
            if Reg.ValueExists('Name')
                then Font.Name := Reg.ReadString('Name')
                else Font.Name := 'MS Sans Serif';
            if Reg.ValueExists('Size')
                then Font.Size := Reg.ReadInteger('Size')
                else Font.Size := 8;
            if Reg.ValueExists('Italic')
                then if Reg.ReadBool('Italic')
                    then Font.Style := Font.Style + [fsItalic]
                    else Font.Style := Font.Style - [fsItalic];
            if Reg.ValueExists('Bold')
                then if Reg.ReadBool('Bold')
                    then Font.Style := Font.Style + [fsBold]
                    else Font.Style := Font.Style - [fsBold];
        end;

    finally
        Reg.CloseKey;
        Reg.Free;
    end;
end;

procedure TFileSystemDialogsSettings.SaveSettings;
var
  Reg: TRegistry;
begin
    Reg := TRegistry.Create;
    try
        Reg.RootKey := HKEY_CURRENT_USER;

        //* Global
        Reg.OpenKey(STR_REG_FD_SETTINGS + '\', True);
        Reg.WriteBool(STR_REG_USE_LAST_FOLDER, UseLastFolder);
        Reg.WriteBool(STR_REG_SINGLE_SETUP, SingleSetup);
        Reg.WriteBool(STR_REG_PRECISION, Precision);
        Reg.WriteBool(STR_REG_READ_CREATED_FOLDER, AutoGoIntoCreatedFolder);
        Reg.WriteBool(STR_REG_SAVE_SETTINGS_ON_CANCEL, SaveSettingsOnCancel);
        Reg.WriteBool(STR_REG_LANCZOS_FOR_THUMBNAILS, LanczosFilterForThumbnails);
        Reg.WriteBool(STR_REG_THUMBNAILS_FOR_DIRS, ThumbnailsForDirs);
        Reg.WriteBool(STR_REG_THUMBNAILS_FOR_DIR_AUDIO, ThumbnailsForDirsAudio);
        Reg.WriteBool(STR_REG_THUMBNAILS_FOR_AUDIOFILES, ThumbnailsForAudioFiles);
        Reg.WriteBool(STR_REG_THUMBNAILS_FOR_TEXTFILES, ThumbnailsForTextFiles);
        Reg.WriteBool(STR_REG_THUMBNAILS_BCKG_COLOR, ThumbnailsUseCustomBckgColor);
        Reg.WriteInteger(STR_REG_THUMBNAILS_BCKG_COLOR_V, ThumbnailsCustomBckgColor);
        Reg.WriteBool(STR_REG_THUMBNAILS_BCKG_PIC_COLOR, ThumbnailsPictureUseCustomBckgColor);
        Reg.WriteInteger(STR_REG_THUMBNAILS_BCKG_PIC_COLOR_V, ThumbnailsPictureCustomBckgColor);
        Reg.WriteBool(STR_REG_THUMBNAILS_FONT_COLOR, ThumbnailsUseCustomFontColor);
        Reg.WriteInteger(STR_REG_THUMBNAILS_FONT_COLOR_FOLDER_V, ThumbnailsUseFolderFontColor);
        Reg.WriteInteger(STR_REG_THUMBNAILS_FONT_COLOR_FILE_V, ThumbnailsUseFileNameColor);
        Reg.WriteInteger(STR_REG_THUMBNAILS_FONT_COLOR_EXT_V, ThumbnailsUseExtColor);
        Reg.WriteBool(STR_REG_THUMBNAILS_ZOOM_X2, ThumbnailsSmallZoomx2);
        Reg.WriteBool(STR_REG_THUMBNAILS_FOLDER_CAP_CENTER, ThumbnailsCenterFolderCaps);
        Reg.WriteBool(STR_REG_THUMBNAILS_AVOID_EXIF, ThumbnailsAvoidEXIF);
        Reg.WriteBool(STR_REG_THREAD_THUMBNAILER, ThumbnailerThreading);
        Reg.WriteInteger(STR_REG_THUMBNAILS_WIDTH, ThumbnailsWidth);
        Reg.WriteInteger(STR_REG_THUMBNAILS_HEIGHT, ThumbnailsHeight);
        Reg.WriteInteger(STR_REG_THUMBNAILS_SIZE_PRESET, ThumbnailsSizePreset);
        Reg.WriteInteger(STR_REG_THUMBNAILS_SAMPLE_COLOR_L, ThumbnailsSampleColorL);
        Reg.WriteInteger(STR_REG_THUMBNAILS_SAMPLE_COLOR_R, ThumbnailsSampleColorR);
        Reg.WriteInteger(STR_REG_THUMBNAILS_SAMPLE_COLOR_B, ThumbnailsSampleColorB);
        Reg.WriteInteger(STR_REG_THUMBNAILS_SAMPLE_AA, ThumbnailsSampleAALEvel);
        Reg.WriteBool(STR_REG_SAVE_SESC, SaveSESC);
        Reg.WriteBool(STR_REG_FS_FORCE_EXTCASE, ForceExtCase);
        Reg.WriteBool(STR_REG_FS_FORCE_EXTCASEU, ForceExtCaseUpper);
        Reg.WriteBool(STR_REG_FS_FORCE_EXTCASEL, ForceExtCaseLower);
        Reg.WriteBool(STR_REG_INACTIVE_TREEVIEW, InactiveTreeViewUntilFirstTouch);
        Reg.WriteBool(STR_REG_OMIT_FILE_EXT, OmitFileExt);
        Reg.WriteBool(STR_REG_ID3_DESCRIPTION, DisplayID3InDescription);
        Reg.WriteInteger(STR_REG_SETTINGS_TOP, SettingsWindowPosition.Y);
        Reg.WriteInteger(STR_REG_SETTINGS_LEFT, SettingsWindowPosition.X);
        Reg.WriteInteger(STR_REG_SETTINGS_PAGE_INDEX, SettingsPageIndex);
        Reg.WriteInteger(STR_REG_SETTINGS_PAGE_THUMBS_INDEX, SettingsPageThumbsIndex);
        Reg.WriteInteger(STR_REG_SETTINGS_PAGE_PREFS_INDEX, SettingsPagePrefsIndex);
        Reg.WriteInteger(STR_REG_RECENT_FOLDER_COUNT, RecentFolderCount);
        Reg.WriteBool(STR_REG_SHOW_SCROLLBAR_RECENT, ShowScrollbarsRecent);
        Reg.WriteBool(STR_REG_SHOW_SCROLLBAR_TREEVIEW, ShowScrollbarsTreeView);
        Reg.WriteBool(STR_REG_THUMBNAILS_CACHED, ThumbnailsCache);
        Reg.WriteBool(STR_REG_SETTINGS_DISPLAY_EXTS_CONVERTED, ConvertDisplayExtensions);
        Reg.WriteBool(STR_REG_SEC_VIEWER, UseSecondaryViewer);
        Reg.WriteBool(STR_REG_SEC_VIEWER_SPECIFY, SecondaryViewerSpecified);
        Reg.WriteInteger(STR_REG_SEC_VIEWER_MONITOR, SecondaryViewerMonitorNo);
        Reg.WriteBool(STR_REG_SEC_VIEWER_AUDIO, SecondaryViewerAudio);
        Reg.WriteBool(STR_REG_SEC_VIEWER_AUDIO_NO_STATUS, SecondaryViewerAudioNoProgress);
        Reg.WriteBool(STR_REG_SEC_VIEWER_AUDIO_NO_INFO, SecondaryViewerAudioNoInfo);
        Reg.WriteInteger(STR_REG_SEC_VIEWER_AUDIO_AA, SecondaryViewerAudioAA);
        Reg.WriteBool(STR_REG_SEC_VIEWER_PICTURE, SecondaryViewerPicture);
        Reg.WriteInteger(STR_REG_SEC_VIEWER_PICTURE_RESAMPLER, SecondaryViewerPictureResampler);
        Reg.WriteBool(STR_REG_SEC_VIEWER_HTML, SecondaryViewerHTML);
        Reg.WriteBool(STR_REG_SEC_VIEWER_TEXT_RTF, SecondaryViewerTEXTRTF);
        Reg.WriteBool(STR_REG_BALLOON_IN_LISTER, BalloonInLister);
        Reg.WriteBool(STR_REG_BALLOON_IN_THUMBNAIL, BalloonInThumbnailMode);
        Reg.WriteBool(STR_REG_BALLOON_THUMBNAILS, BalloonHasThumbs);
        Reg.WriteInteger(STR_REG_BALLOON_HINT_TIMEOUT, BalloonHintTimeOut);
        Reg.WriteString(STR_REG_TYPES_BROWSER, TypesBrowser);
        Reg.WriteString(STR_REG_TYPES_AUDIO, TypesAudio);
        Reg.WriteString(STR_REG_TYPES_TEXT, TypesText);
        Reg.WriteBool(STR_REG_BALLOON_IN_DRIVES, BalloonInDrives);
        Reg.WriteBool(STR_REG_GRID_LINES, EnableGridLines);
        Reg.WriteBool(STR_REG_URL_DECODE_FILENAMES, AutoURLDecodeFileNames);
        Reg.WriteBool(STR_REG_UPPERCASE_FIRST_LETTER_FOR_FILENAMES, AutoConvertFirstLetterInFileNames);
        Reg.WriteBool(STR_REG_UNDERSCORES_2_SPACE_FOR_FILENAMES, AutoConvertUnderscoresInFileNames);
        Reg.WriteInteger(STR_REG_RECENT_FILES_COUNT, RecentFileCount);
        Reg.WriteBool(STR_REG_DONTDISAPLAY_TFDDB, DontDisplayTFDDB);
        Reg.WriteString(STR_REG_FILENAME_TEMPLATE, FilenameTemplate);
        Reg.WriteBool(STR_REG_RECENT_FILES_DEL_INVALID, AutoDelInvalidRecentLinks);
        Reg.WriteBool(STR_REG_THUMBNAILS_FOR_AUDIOFILES_APIC, ThumbnailsForAudioFilesAsAPIC);
        Reg.WriteInteger(STR_REG_THUMBNAILER_TEXT_ZOOM, ThumbnailerTextZoom);
        Reg.WriteBool(STR_REG_SEC_VIEWER_HTML_UNKNOWN_TYPES, SecondaryViewerHTMLAllFiles);
        Reg.WriteBool(STR_REG_NO_CDN_TYPECHANGE, NoCDN_TYPECHANGE);
        Reg.WriteBool(STR_REG_LISTER_HAS_THE_FOCUS, ListerHasTheFocus);
        Reg.WriteBool(STR_REG_BALLOON_NO_FILENAME_FOCUS, NoBalloonWhenFileNameHasFocus);

        Reg.CloseKey;

        //* Font
        Reg.OpenKey(STR_REG_FD_SETTINGS + '\' + STR_REG_FD_FONT_SETTINGS + '\', True);
        Reg.WriteString('Name', Font.Name);
        Reg.WriteInteger('Size', Font.Size);
        Reg.WriteBool('Italic', fsItalic in Font.Style);
        Reg.WriteBool('Bold', fsBold in Font.Style);

    finally
        Reg.CloseKey;
        Reg.Free;
    end;
end;

end.



