unit main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, id3;

type
  TID3TaggerForm = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    ID3title: TEdit;
    ID3artist: TEdit;
    ID3year: TEdit;
    Label6: TLabel;
    ID3track: TEdit;
    OpenDialog: TOpenDialog;
    LoadButton: TButton;
    SaveButton: TButton;
    ID3album: TEdit;
    Label3: TLabel;
    ID3comment: TEdit;
    Label7: TLabel;
    RemoveButton: TButton;
    ID3genre: TComboBox;
    procedure ID3trackKeyPress(Sender: TObject; var Key: Char);
    procedure LoadButtonClick(Sender: TObject);
    procedure SaveButtonClick(Sender: TObject);
    procedure RemoveButtonClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  ID3TaggerForm: TID3TaggerForm;
  myTag: Tid3Tag;


implementation

{$R *.DFM}

{******************************************************************************}
//Restricts the "Year" field to numeric digits only.

procedure TID3TaggerForm.ID3trackKeyPress(Sender: TObject; var Key: Char);
begin
if ((ord(Key) > 57) or (ord(Key) < 48)) and not(ord(Key) = 8) then
 Key := chr(0);
end;
{end***************************************************************************}

{******************************************************************************}
//Loads the tag into memory for editing

procedure TID3TaggerForm.LoadButtonClick(Sender: TObject);
var
tempInt : word;
begin
if OpenDialog.execute then
 begin
 tempInt := myTag.loadFromFile(OpenDialog.filename);
 if (tempInt > 255) then
  showMessage(format('Error #%d! Could not load Tag!',[tempInt])) else
   begin
   ID3title.text := myTag.title;
   ID3artist.text := myTag.artist;
   ID3album.text := myTag.album;
   ID3year.text := myTag.year;

   //Gets the appropriate itemIndex value for this genre for the dropbox
   //If your dropbox starts at index 0 (ie. does not contain an empty entry
   //as the first item), make sure to subtrack myTag.genre by 1 before calling
   //the genreDataToList function. (Add 1 to itemIndex for genreListToData)
   ID3genre.ItemIndex := genreDataToList(myTag.genre);

   ID3comment.text := myTag.comment;
   ID3track.text := inttostr(myTag.track);
   end;
 end;
end;
{end***************************************************************************}

{******************************************************************************}
//Saves the current tag in memory to the specified file

procedure TID3TaggerForm.SaveButtonClick(Sender: TObject);
var
tempInt : word;
begin
myTag.title := ID3title.text;
myTag.artist := ID3artist.text;
myTag.album := ID3album.text;
myTag.year := ID3year.text;

//Opposite of genreDataToList for reverting the itemIndex to the proper genre
//byte value. Add 1 to itemIndex before calling the function if you are not
//using an empty first item. (See genreDataToList description above)
myTag.genre := genreListToData(ID3genre.ItemIndex);

myTag.comment := ID3comment.text;
if length(ID3track.text) > 0 then
 myTag.track := strtoint(ID3track.text);
tempInt := myTag.saveToFile;
if (tempInt > 255) then
 showMessage(format('Error #%d! Could not save Tag!',[tempInt]));
end;
{end***************************************************************************}

{******************************************************************************}
//Removes the tag from the file. Use killTag to remove the tag without loading.

procedure TID3TaggerForm.RemoveButtonClick(Sender: TObject);
begin
myTag.kill;
end;
{end***************************************************************************}

initialization
myTag := Tid3tag.create;

finalization
if myTag <> nil then
 myTag.free;

end.

