unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms, SampleDisplay2D, GR32, StdCtrls, GR32_Image, Dialogs, ExtCtrls,
  ComCtrls, BASS, BASSSampler, FilesystemDialogsDefs, Spin, Helper3delite;

type
  TForm1 = class(TForm)
    Button2: TButton;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    GroupBox1: TGroupBox;
    Panel1: TPanel;
    ImageAudio: TImage32;
    Edit1: TEdit;
    Button1: TButton;
    Button3: TButton;
    GroupBox2: TGroupBox;
    Panel2: TPanel;
    Button4: TButton;
    Image1: TImage;
    TabSheet3: TTabSheet;
    GroupBox3: TGroupBox;
    Panel3: TPanel;
    Button6: TButton;
    Image2: TImage;
    TabSheet4: TTabSheet;
    GroupBox4: TGroupBox;
    Panel4: TPanel;
    Image321: TImage32;
    Button8: TButton;
    GroupBox5: TGroupBox;
    Label1: TLabel;
    FilesystemDialog: TFilesystemDialog;
    Label2: TLabel;
    SpinEdit1: TSpinEdit;
    Edit2: TEdit;
    Label3: TLabel;
    Label4: TLabel;
    Edit3: TEdit;
    Label5: TLabel;
    Button5: TButton;
    Button7: TButton;
    Button9: TButton;
    Button10: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button8Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button10Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure Button9Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    function ProgressCallback(FileName: String; Progress: Double; var AbortSampling: Boolean; EventType: TSampleDisplayEvent; User: Pointer): Boolean; stdcall;
  end;

var
  Form1: TForm1;
                                                           
implementation

{$R *.dfm}

function TForm1.ProgressCallback(FileName: String; Progress: Double; var AbortSampling: Boolean; EventType: TSampleDisplayEvent; User: Pointer): Boolean; stdcall;
var
  State: String;
begin
    if EventType = sdeSampling
        then State := 'Sampling ';
    if EventType = sdeDrawing
        then State := 'Drawing ';
    if EventType = sdeStretching
        then State := 'Stretching ';
    Form1.Caption := State + FloatToStr(Progress) + '%';
    Result := True;
end;

procedure TForm1.Button1Click(Sender: TObject);
var
  SampleOptions: TSamplePictureOptions;
  SampleDisplay2D: TSampleDisplay2DThread;
begin

    //* With threading
    try
        try
            ZeroMemory(@SampleOptions, SizeOf(TSamplePictureOptions));
            SampleOptions.SampleLeft := HexToInt(Edit2.Text);
            SampleOptions.SampleRight := HexToInt(Edit3.Text);
            SampleOptions.SampleBackground := clBlack32;
            SampleOptions.AntiAliasingLevel := SpinEdit1.Value;
            SampleOptions.SaveSESC := True;
            SampleOptions.ProgressCallback := ProgressCallback;
            //* Reasonable value is between 250 - 1000 ms
            SampleOptions.CallbackInterval := 20;
            SampleOptions.UseThumbDatabase := True;
            SampleOptions.SaveThumbDatabase := False;
            //* TSampleDisplay2D expects for an existing (width x height) bitmap
            if ImageAudio.Bitmap.Empty then begin
                ImageAudio.Bitmap.Width := ImageAudio.Width;
                ImageAudio.Bitmap.Height := ImageAudio.Height;
                ImageAudio.Bitmap.Clear(clBlack32);
            end;
            SampleDisplay2D := TSampleDisplay2DThread.Create(Edit1.Text, ImageAudio.Bitmap, SampleOptions);
            SampleDisplay2D.Resume;
        except
            //* Error
        end;
    finally
        //* Nothing
    end;

end;

procedure TForm1.Button3Click(Sender: TObject);
begin
    FilesystemDialog.FileName := Edit1.Text;
    if NOT FilesystemDialog.Execute
        then Exit;
    Edit1.Text := FilesystemDialog.FileName;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
    Close;
end;

procedure TForm1.Button4Click(Sender: TObject);
var
  SampleOptions: TSamplePictureOptions;
begin

    //* Without threading
    try
        try
            ZeroMemory(@SampleOptions, SizeOf(TSamplePictureOptions));
            SampleOptions.SampleLeft := HexToInt(Edit2.Text);
            SampleOptions.SampleRight := HexToInt(Edit3.Text);
            SampleOptions.SampleBackground := clBlack32;
            SampleOptions.AntiAliasingLevel := SpinEdit1.Value;
            SampleOptions.SaveSESC := True;
            SampleOptions.ProgressCallback := nil;
            SampleOptions.UseThumbDatabase := True;
            SampleOptions.SaveThumbDatabase := False;
            //* TSampleDisplay2D expects for an existing (width x height) bitmap
            if Image1.Picture.Bitmap.Empty then begin
                Image1.Picture.Bitmap.Width := Image1.Width;
                Image1.Picture.Bitmap.Height := Image1.Height;
                Image1.Picture.Bitmap.Canvas.FloodFill(0, 0, WinColor(SampleOptions.SampleBackground), fsSurface);
            end;
            SampleDisplay2D.CreatePictureFromAudioFile(Edit1.Text, Image1.Picture.Bitmap, SampleOptions);
        except
            //* Error
        end;
    finally
        //* Nothing
    end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
    DoubleBuffered := True;

    Image1.Picture.LoadFromFile('abstract8_107.bmp');
    ImageAudio.Bitmap.LoadFromFile('abstract8_107.bmp');
    Image2.Picture.LoadFromFile('abstract8_107.bmp');
    Image321.Bitmap.LoadFromFile('abstract8_107.bmp');

    //* Initialize BASS
	if (HIWORD(BASS_GetVersion) <> BASSVERSION) then begin
		MessageDlg('BASS version 2.3 was not loaded!', mtError, [mbOk], 0);
		Halt;
	end;
	if not BASS_Init(-1, 44100, 0, Handle, nil) then begin
		MessageDlg('Cannot start default audio device!', mtError, [mbOk], 0);
	end;

    CheckBASSAvailability;
    
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
    BASS_Stop;
    BASS_Free;
end;

procedure TForm1.Button6Click(Sender: TObject);
var
  SampleOptions: TSamplePictureOptions;
  SampleDisplay2D: TSampleDisplay2DTBitmapThread;
begin

    //* With threading
    try
        try
            ZeroMemory(@SampleOptions, SizeOf(TSamplePictureOptions));
            SampleOptions.SampleLeft := HexToInt(Edit2.Text);
            SampleOptions.SampleRight := HexToInt(Edit3.Text);
            SampleOptions.SampleBackground := clBlack32;
            SampleOptions.AntiAliasingLevel := SpinEdit1.Value;
            SampleOptions.SaveSESC := True;
            SampleOptions.ProgressCallback := ProgressCallback;
            //* Reasonable value is between 250 - 1000 ms
            SampleOptions.CallbackInterval := 20;
            SampleOptions.UseThumbDatabase := True;
            SampleOptions.SaveThumbDatabase := False;
            //* TSampleDisplay2D expects for an existing (width x height) bitmap
            if Image2.Picture.Bitmap.Empty then begin
                Image1.Picture.Bitmap.Width := Image1.Width;
                Image1.Picture.Bitmap.Height := Image1.Height;
                Image1.Picture.Bitmap.Canvas.FloodFill(0, 0, WinColor(SampleOptions.SampleBackground), fsSurface);
            end;
            SampleDisplay2D := TSampleDisplay2DTBitmapThread.Create(Edit1.Text, Image2.Picture.Bitmap, SampleOptions);
            SampleDisplay2D.Resume;
        except
            //* Error
        end;
    finally
        //* Nothing
    end;
end;

procedure TForm1.Button8Click(Sender: TObject);
var
  SampleOptions: TSamplePictureOptions;
begin

    //* Without threading
    try                      
        try
            ZeroMemory(@SampleOptions, SizeOf(TSamplePictureOptions));
            SampleOptions.SampleLeft := HexToInt(Edit2.Text);
            SampleOptions.SampleRight := HexToInt(Edit3.Text);
            SampleOptions.SampleBackground := clBlack32;
            SampleOptions.AntiAliasingLevel := SpinEdit1.Value;
            SampleOptions.SaveSESC := True;
            SampleOptions.ProgressCallback := nil;
            SampleOptions.UseThumbDatabase := True;
            SampleOptions.SaveThumbDatabase := False;
            //* TSampleDisplay2D expects for an existing (width x height) bitmap
            if Image321.Bitmap.Empty then begin
                Image321.Bitmap.Width := Image1.Width;
                Image321.Bitmap.Height := Image1.Height;
                Image321.Bitmap.Canvas.FloodFill(0, 0, WinColor(SampleOptions.SampleBackground), fsSurface);
            end;
            SampleDisplay2D.CreatePictureFromAudioFile(Edit1.Text, Image321.Bitmap, SampleOptions);
        except
            //* Error
        end;
    finally
        //* Nothing
    end;

end;

procedure TForm1.Button5Click(Sender: TObject);
begin
    ImageAudio.Bitmap.LoadFromFile('abstract8_107.bmp');
end;

procedure TForm1.Button10Click(Sender: TObject);
begin
    Image1.Picture.LoadFromFile('abstract8_107.bmp');
end;

procedure TForm1.Button7Click(Sender: TObject);
begin
    Image321.Bitmap.LoadFromFile('abstract8_107.bmp');
end;

procedure TForm1.Button9Click(Sender: TObject);
begin
    Image2.Picture.LoadFromFile('abstract8_107.bmp');
end;

end.



